




      module mo_nln_matrix

      use shr_kind_mod, only : r8 => shr_kind_r8

      private
      public :: nlnmat

      contains

      subroutine nlnmat01( mat, y, rxt )

      use chem_mods, only : gas_pcnst, rxntot, nzcnt

      implicit none

!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      real(r8), intent(in) :: y(gas_pcnst)
      real(r8), intent(in) :: rxt(rxntot)
      real(r8), intent(inout) :: mat(nzcnt)


!----------------------------------------------
! ... local variables
!----------------------------------------------

!----------------------------------------------
! ... complete matrix entries implicit species
!----------------------------------------------


         mat(760) = -(rxt(42)*y(2) + rxt(50)*y(12) + rxt(51)*y(13) + rxt(60)*y(5) &
                      + rxt(62)*y(6) + rxt(91)*y(22) + rxt(116)*y(33) + rxt(147)*y(50) &
                      + rxt(159)*y(53) + rxt(161)*y(54) + rxt(199)*y(63))
         mat(252) = -rxt(42)*y(1)
         mat(686) = -rxt(50)*y(1)
         mat(607) = -rxt(51)*y(1)
         mat(730) = -rxt(60)*y(1)
         mat(831) = -rxt(62)*y(1)
         mat(156) = -rxt(91)*y(1)
         mat(406) = -rxt(116)*y(1)
         mat(383) = -rxt(147)*y(1)
         mat(538) = -rxt(159)*y(1)
         mat(458) = -rxt(161)*y(1)
         mat(280) = -rxt(199)*y(1)

         mat(760) = mat(760) + .100_r8*rxt(147)*y(50) + .200_r8*rxt(159)*y(53) &
                      + .200_r8*rxt(161)*y(54)
         mat(607) = mat(607) + .250_r8*rxt(105)*y(31) + .250_r8*rxt(171)*y(57)
         mat(811) = .250_r8*rxt(105)*y(13)
         mat(383) = mat(383) + .100_r8*rxt(147)*y(1)
         mat(538) = mat(538) + .200_r8*rxt(159)*y(1)
         mat(458) = mat(458) + .200_r8*rxt(161)*y(1)
         mat(553) = .250_r8*rxt(171)*y(13)


         mat(248) = -(rxt(42)*y(1) + rxt(48)*y(12) + rxt(49)*y(13) + rxt(61)*y(6))
         mat(740) = -rxt(42)*y(2)
         mat(655) = -rxt(48)*y(2)
         mat(581) = -rxt(49)*y(2)
         mat(822) = -rxt(61)*y(2)

         mat(655) = mat(655) + 2.000_r8*rxt(55)*y(12)

         mat(729) = -(rxt(59)*y(13) + rxt(60)*y(1) + rxt(68)*y(7) + rxt(74)*y(17) &
                      + rxt(87)*y(120) + rxt(92)*y(24) + rxt(96)*y(28) + rxt(103) &
                      *y(31) + rxt(118)*y(37) + rxt(122)*y(35) + rxt(127)*y(40) &
                      + rxt(136)*y(43) + rxt(138)*y(45) + rxt(143)*y(48) + rxt(148) &
                      *y(51) + rxt(155)*y(84) + (rxt(162) + rxt(163)) * y(55) + rxt(169) &
                      *y(57) + rxt(180)*y(61) + rxt(190)*y(68) + rxt(195)*y(71) &
                      + rxt(198)*y(75) + rxt(202)*y(64))
         mat(606) = -rxt(59)*y(5)
         mat(759) = -rxt(60)*y(5)
         mat(862) = -rxt(68)*y(5)
         mat(788) = -rxt(74)*y(5)
         mat(190) = -rxt(87)*y(5)
         mat(183) = -rxt(92)*y(5)
         mat(355) = -rxt(96)*y(5)
         mat(810) = -rxt(103)*y(5)
         mat(319) = -rxt(118)*y(5)
         mat(366) = -rxt(122)*y(5)
         mat(426) = -rxt(127)*y(5)
         mat(123) = -rxt(136)*y(5)
         mat(304) = -rxt(138)*y(5)
         mat(343) = -rxt(143)*y(5)
         mat(521) = -rxt(148)*y(5)
         mat(327) = -rxt(155)*y(5)
         mat(502) = -(rxt(162) + rxt(163)) * y(5)
         mat(552) = -rxt(169)*y(5)
         mat(485) = -rxt(180)*y(5)
         mat(240) = -rxt(190)*y(5)
         mat(82) = -rxt(195)*y(5)
         mat(94) = -rxt(198)*y(5)
         mat(441) = -rxt(202)*y(5)

         mat(251) = rxt(61)*y(6)
         mat(830) = rxt(61)*y(2)

         mat(834) = -(rxt(61)*y(2) + rxt(62)*y(1) + rxt(64)*y(7) + rxt(66)*y(12) &
                      + rxt(69)*y(13) + rxt(104)*y(31) + rxt(175)*y(57) + rxt(189) &
                      *y(78))
         mat(253) = -rxt(61)*y(6)
         mat(763) = -rxt(62)*y(6)
         mat(866) = -rxt(64)*y(6)
         mat(689) = -rxt(66)*y(6)
         mat(610) = -rxt(69)*y(6)
         mat(814) = -rxt(104)*y(6)
         mat(556) = -rxt(175)*y(6)
         mat(77) = -rxt(189)*y(6)

         mat(763) = mat(763) + rxt(60)*y(5)
         mat(733) = rxt(60)*y(1) + 2.000_r8*rxt(68)*y(7) + rxt(59)*y(13) + rxt(74) &
                      *y(17) + rxt(92)*y(24) + rxt(96)*y(28) + rxt(103)*y(31) &
                      + rxt(122)*y(35) + rxt(118)*y(37) + rxt(127)*y(40) + rxt(136) &
                      *y(43) + .900_r8*rxt(143)*y(48) + rxt(138)*y(45) &
                      + .920_r8*rxt(148)*y(51) + rxt(162)*y(55) + rxt(169)*y(57) &
                      + rxt(180)*y(61) + rxt(202)*y(64) + .900_r8*rxt(190)*y(68) &
                      + 1.206_r8*rxt(155)*y(84) + rxt(87)*y(120)
         mat(834) = mat(834) + .700_r8*rxt(189)*y(78)
         mat(866) = mat(866) + 2.000_r8*rxt(68)*y(5) + rxt(63)*y(13) + rxt(149)*y(51) &
                      + rxt(164)*y(55) + rxt(170)*y(57) + rxt(181)*y(61) + rxt(201) &
                      *y(63) + 1.206_r8*rxt(156)*y(84) + rxt(178)*y(85)
         mat(138) = rxt(70)*y(12)
         mat(689) = mat(689) + rxt(70)*y(9) + rxt(131)*y(82) + .400_r8*rxt(177)*y(85)
         mat(610) = mat(610) + rxt(59)*y(5) + rxt(63)*y(7) + .206_r8*rxt(157)*y(84)
         mat(792) = rxt(74)*y(5)
         mat(184) = rxt(92)*y(5)
         mat(357) = rxt(96)*y(5)
         mat(814) = mat(814) + rxt(103)*y(5)
         mat(369) = rxt(122)*y(5)
         mat(320) = rxt(118)*y(5)
         mat(429) = rxt(127)*y(5)
         mat(124) = rxt(136)*y(5)
         mat(346) = .900_r8*rxt(143)*y(5)
         mat(306) = rxt(138)*y(5)
         mat(525) = .920_r8*rxt(148)*y(5) + rxt(149)*y(7)
         mat(505) = rxt(162)*y(5) + rxt(164)*y(7)
         mat(556) = mat(556) + rxt(169)*y(5) + rxt(170)*y(7)
         mat(488) = rxt(180)*y(5) + rxt(181)*y(7)
         mat(281) = rxt(201)*y(7)
         mat(444) = rxt(202)*y(5)
         mat(241) = .900_r8*rxt(190)*y(5)
         mat(77) = mat(77) + .700_r8*rxt(189)*y(6)
         mat(177) = rxt(131)*y(12)
         mat(328) = 1.206_r8*rxt(155)*y(5) + 1.206_r8*rxt(156)*y(7) + .206_r8*rxt(157) &
                      *y(13)
         mat(393) = rxt(178)*y(7) + .400_r8*rxt(177)*y(12)
         mat(191) = rxt(87)*y(5)

         mat(867) = -(rxt(63)*y(13) + rxt(64)*y(6) + rxt(68)*y(5) + rxt(79)*y(19) &
                      + rxt(102)*y(30) + rxt(117)*y(33) + rxt(133)*y(60) + rxt(149) &
                      *y(51) + rxt(154)*y(50) + rxt(156)*y(84) + rxt(164)*y(55) &
                      + rxt(170)*y(57) + rxt(178)*y(85) + rxt(181)*y(61) + rxt(201) &
                      *y(63) + rxt(213)*y(101))
         mat(611) = -rxt(63)*y(7)
         mat(835) = -rxt(64)*y(7)
         mat(734) = -rxt(68)*y(7)
         mat(467) = -rxt(79)*y(7)
         mat(417) = -rxt(102)*y(7)
         mat(409) = -rxt(117)*y(7)
         mat(474) = -rxt(133)*y(7)
         mat(526) = -rxt(149)*y(7)
         mat(386) = -rxt(154)*y(7)
         mat(329) = -rxt(156)*y(7)
         mat(506) = -rxt(164)*y(7)
         mat(557) = -rxt(170)*y(7)
         mat(394) = -rxt(178)*y(7)
         mat(489) = -rxt(181)*y(7)
         mat(282) = -rxt(201)*y(7)
         mat(108) = -rxt(213)*y(7)

         mat(764) = rxt(62)*y(6)
         mat(835) = mat(835) + rxt(62)*y(1)
         mat(229) = rxt(67)*y(12)
         mat(690) = rxt(67)*y(8) + rxt(108)*y(81) + .500_r8*rxt(141)*y(83)
         mat(218) = rxt(108)*y(12)
         mat(261) = .500_r8*rxt(141)*y(12)

         mat(226) = -(rxt(67)*y(12))
         mat(651) = -rxt(67)*y(8)

         mat(820) = rxt(66)*y(12)
         mat(841) = rxt(79)*y(19) + rxt(102)*y(30) + rxt(133)*y(60) + rxt(213)*y(101)
         mat(651) = mat(651) + rxt(66)*y(6)
         mat(461) = rxt(79)*y(7)
         mat(410) = rxt(102)*y(7)
         mat(468) = rxt(133)*y(7)
         mat(105) = rxt(213)*y(7)

         mat(135) = -(rxt(70)*y(12))
         mat(635) = -rxt(70)*y(9)

         mat(818) = rxt(69)*y(13)
         mat(567) = rxt(69)*y(6)


         mat(817) = rxt(64)*y(7)
         mat(837) = rxt(64)*y(6)

         mat(684) = -(rxt(48)*y(2) + rxt(50)*y(1) + rxt(53)*y(14) + rxt(54)*y(13) &
                      + (4._r8*rxt(55) + 4._r8*rxt(56)) * y(12) + rxt(66)*y(6) + rxt(67) &
                      *y(8) + rxt(70)*y(9) + rxt(78)*y(18) + rxt(80)*y(19) + rxt(83) &
                      *y(20) + rxt(84)*y(119) + rxt(89)*y(118) + rxt(90)*y(22) + rxt(95) &
                      *y(27) + rxt(100)*y(29) + rxt(101)*y(30) + rxt(107)*y(32) &
                      + rxt(108)*y(81) + rxt(111)*y(26) + rxt(112)*y(80) + rxt(113) &
                      *y(25) + rxt(114)*y(21) + rxt(115)*y(33) + rxt(120)*y(38) &
                      + rxt(121)*y(34) + rxt(125)*y(36) + rxt(126)*y(39) + rxt(130) &
                      *y(41) + rxt(131)*y(82) + rxt(132)*y(60) + rxt(134)*y(59) &
                      + rxt(135)*y(42) + rxt(137)*y(44) + rxt(140)*y(46) + rxt(141) &
                      *y(83) + rxt(142)*y(47) + rxt(145)*y(49) + rxt(146)*y(50) &
                      + rxt(151)*y(52) + rxt(158)*y(53) + rxt(160)*y(54) + rxt(168) &
                      *y(56) + rxt(177)*y(85) + rxt(179)*y(58) + rxt(185)*y(62) &
                      + rxt(187)*y(66) + rxt(188)*y(67) + rxt(192)*y(69) + rxt(193) &
                      *y(70) + rxt(196)*y(74) + rxt(200)*y(63) + rxt(204)*y(65) &
                      + rxt(210)*y(100) + (rxt(211) + rxt(212)) * y(101) + rxt(214) &
                      *y(103))
         mat(250) = -rxt(48)*y(12)
         mat(758) = -rxt(50)*y(12)
         mat(65) = -rxt(53)*y(12)
         mat(605) = -rxt(54)*y(12)
         mat(829) = -rxt(66)*y(12)
         mat(227) = -rxt(67)*y(12)
         mat(137) = -rxt(70)*y(12)
         mat(148) = -rxt(78)*y(12)
         mat(464) = -rxt(80)*y(12)
         mat(265) = -rxt(83)*y(12)
         mat(159) = -rxt(84)*y(12)
         mat(70) = -rxt(89)*y(12)
         mat(155) = -rxt(90)*y(12)
         mat(51) = -rxt(95)*y(12)
         mat(164) = -rxt(100)*y(12)
         mat(413) = -rxt(101)*y(12)
         mat(202) = -rxt(107)*y(12)
         mat(214) = -rxt(108)*y(12)
         mat(287) = -rxt(111)*y(12)
         mat(232) = -rxt(112)*y(12)
         mat(198) = -rxt(113)*y(12)
         mat(112) = -rxt(114)*y(12)
         mat(404) = -rxt(115)*y(12)
         mat(211) = -rxt(120)*y(12)
         mat(48) = -rxt(121)*y(12)
         mat(144) = -rxt(125)*y(12)
         mat(309) = -rxt(126)*y(12)
         mat(133) = -rxt(130)*y(12)
         mat(176) = -rxt(131)*y(12)
         mat(471) = -rxt(132)*y(12)
         mat(449) = -rxt(134)*y(12)
         mat(36) = -rxt(135)*y(12)
         mat(195) = -rxt(137)*y(12)
         mat(128) = -rxt(140)*y(12)
         mat(259) = -rxt(141)*y(12)
         mat(39) = -rxt(142)*y(12)
         mat(297) = -rxt(145)*y(12)
         mat(381) = -rxt(146)*y(12)
         mat(273) = -rxt(151)*y(12)
         mat(536) = -rxt(158)*y(12)
         mat(457) = -rxt(160)*y(12)
         mat(117) = -rxt(168)*y(12)
         mat(392) = -rxt(177)*y(12)
         mat(167) = -rxt(179)*y(12)
         mat(73) = -rxt(185)*y(12)
         mat(59) = -rxt(187)*y(12)
         mat(62) = -rxt(188)*y(12)
         mat(173) = -rxt(192)*y(12)
         mat(42) = -rxt(193)*y(12)
         mat(45) = -rxt(196)*y(12)
         mat(279) = -rxt(200)*y(12)
         mat(225) = -rxt(204)*y(12)
         mat(54) = -rxt(210)*y(12)
         mat(107) = -(rxt(211) + rxt(212)) * y(12)
         mat(33) = -rxt(214)*y(12)

         mat(758) = mat(758) + rxt(51)*y(13) + .120_r8*rxt(91)*y(22) &
                      + .330_r8*rxt(116)*y(33) + .270_r8*rxt(147)*y(50) &
                      + .080_r8*rxt(159)*y(53) + .215_r8*rxt(161)*y(54) &
                      + .700_r8*rxt(199)*y(63)
         mat(250) = mat(250) + rxt(49)*y(13)
         mat(728) = rxt(59)*y(13)
         mat(861) = rxt(63)*y(13)
         mat(684) = mat(684) + .300_r8*rxt(78)*y(18) + .500_r8*rxt(100)*y(29) &
                      + .500_r8*rxt(120)*y(38) + .100_r8*rxt(168)*y(56) &
                      + .650_r8*rxt(89)*y(118)
         mat(605) = mat(605) + rxt(51)*y(1) + rxt(49)*y(2) + rxt(59)*y(5) + rxt(63) &
                      *y(7)
         mat(148) = mat(148) + .300_r8*rxt(78)*y(12)
         mat(155) = mat(155) + .120_r8*rxt(91)*y(1)
         mat(164) = mat(164) + .500_r8*rxt(100)*y(12)
         mat(404) = mat(404) + .330_r8*rxt(116)*y(1)
         mat(211) = mat(211) + .500_r8*rxt(120)*y(12)
         mat(381) = mat(381) + .270_r8*rxt(147)*y(1)
         mat(536) = mat(536) + .080_r8*rxt(159)*y(1)
         mat(457) = mat(457) + .215_r8*rxt(161)*y(1)
         mat(117) = mat(117) + .100_r8*rxt(168)*y(12)
         mat(279) = mat(279) + .700_r8*rxt(199)*y(1)
         mat(70) = mat(70) + .650_r8*rxt(89)*y(12)


      end subroutine nlnmat01

      subroutine nlnmat02( mat, y, rxt )

      use chem_mods, only : gas_pcnst, rxntot, nzcnt

      implicit none

!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      real(r8), intent(in) :: y(gas_pcnst)
      real(r8), intent(in) :: rxt(rxntot)
      real(r8), intent(inout) :: mat(nzcnt)


!----------------------------------------------
! ... local variables
!----------------------------------------------

!----------------------------------------------
! ... complete matrix entries implicit species
!----------------------------------------------


         mat(604) = -(rxt(49)*y(2) + rxt(51)*y(1) + 4._r8*rxt(52)*y(13) + rxt(54) &
                      *y(12) + rxt(59)*y(5) + rxt(63)*y(7) + rxt(69)*y(6) + rxt(77) &
                      *y(17) + rxt(85)*y(19) + rxt(88)*y(120) + rxt(97)*y(28) + rxt(105) &
                      *y(31) + rxt(119)*y(37) + rxt(123)*y(35) + rxt(128)*y(40) &
                      + rxt(139)*y(45) + rxt(144)*y(48) + rxt(150)*y(51) + rxt(157) &
                      *y(84) + rxt(165)*y(55) + rxt(171)*y(57) + rxt(182)*y(61) &
                      + rxt(191)*y(68) + rxt(194)*y(71) + rxt(197)*y(75) + rxt(203) &
                      *y(64))
         mat(249) = -rxt(49)*y(13)
         mat(757) = -rxt(51)*y(13)
         mat(683) = -rxt(54)*y(13)
         mat(727) = -rxt(59)*y(13)
         mat(860) = -rxt(63)*y(13)
         mat(828) = -rxt(69)*y(13)
         mat(786) = -rxt(77)*y(13)
         mat(463) = -rxt(85)*y(13)
         mat(188) = -rxt(88)*y(13)
         mat(353) = -rxt(97)*y(13)
         mat(808) = -rxt(105)*y(13)
         mat(317) = -rxt(119)*y(13)
         mat(364) = -rxt(123)*y(13)
         mat(424) = -rxt(128)*y(13)
         mat(302) = -rxt(139)*y(13)
         mat(341) = -rxt(144)*y(13)
         mat(519) = -rxt(150)*y(13)
         mat(326) = -rxt(157)*y(13)
         mat(500) = -rxt(165)*y(13)
         mat(550) = -rxt(171)*y(13)
         mat(483) = -rxt(182)*y(13)
         mat(238) = -rxt(191)*y(13)
         mat(81) = -rxt(194)*y(13)
         mat(93) = -rxt(197)*y(13)
         mat(439) = -rxt(203)*y(13)

         mat(757) = mat(757) + rxt(50)*y(12) + .120_r8*rxt(91)*y(22) &
                      + .190_r8*rxt(116)*y(33) + .060_r8*rxt(147)*y(50) &
                      + .060_r8*rxt(159)*y(53) + .275_r8*rxt(161)*y(54) + rxt(199) &
                      *y(63)
         mat(249) = mat(249) + rxt(48)*y(12)
         mat(727) = mat(727) + rxt(74)*y(17) + rxt(96)*y(28) + rxt(122)*y(35) &
                      + rxt(118)*y(37) + rxt(136)*y(43) + .900_r8*rxt(143)*y(48) &
                      + rxt(148)*y(51) + .470_r8*rxt(162)*y(55) + rxt(180)*y(61) &
                      + rxt(202)*y(64) + .900_r8*rxt(190)*y(68) + .794_r8*rxt(155) &
                      *y(84) + rxt(87)*y(120)
         mat(828) = mat(828) + .700_r8*rxt(189)*y(78)
         mat(860) = mat(860) + rxt(79)*y(19) + rxt(149)*y(51) + .470_r8*rxt(164)*y(55) &
                      + rxt(181)*y(61) + .794_r8*rxt(156)*y(84) + rxt(178)*y(85)
         mat(683) = mat(683) + rxt(50)*y(1) + rxt(48)*y(2) + rxt(53)*y(14) + rxt(80) &
                      *y(19) + rxt(83)*y(20) + rxt(114)*y(21) + .250_r8*rxt(90)*y(22) &
                      + rxt(111)*y(26) + .200_r8*rxt(168)*y(56) + rxt(134)*y(59) &
                      + .250_r8*rxt(187)*y(66) + rxt(112)*y(80) + .500_r8*rxt(141) &
                      *y(83) + rxt(177)*y(85) + .500_r8*rxt(212)*y(101) &
                      + .350_r8*rxt(89)*y(118) + rxt(84)*y(119)
         mat(604) = mat(604) + .794_r8*rxt(157)*y(84)
         mat(64) = rxt(53)*y(12)
         mat(786) = mat(786) + rxt(74)*y(5) + 4.000_r8*rxt(75)*y(17) + rxt(98)*y(28) &
                      + .900_r8*rxt(106)*y(31) + rxt(124)*y(35) + .300_r8*rxt(129) &
                      *y(40) + rxt(152)*y(51) + .730_r8*rxt(166)*y(55) + rxt(172) &
                      *y(57) + .800_r8*rxt(183)*y(61)
         mat(463) = mat(463) + rxt(79)*y(7) + rxt(80)*y(12)
         mat(264) = rxt(83)*y(12)
         mat(111) = rxt(114)*y(12)
         mat(154) = .120_r8*rxt(91)*y(1) + .250_r8*rxt(90)*y(12)
         mat(286) = rxt(111)*y(12)
         mat(353) = mat(353) + rxt(96)*y(5) + rxt(98)*y(17) + 2.400_r8*rxt(99)*y(28)
         mat(808) = mat(808) + .900_r8*rxt(106)*y(17) + rxt(153)*y(51) &
                      + .470_r8*rxt(167)*y(55) + rxt(184)*y(61)
         mat(403) = .190_r8*rxt(116)*y(1)
         mat(364) = mat(364) + rxt(122)*y(5) + rxt(124)*y(17)
         mat(317) = mat(317) + rxt(118)*y(5)
         mat(424) = mat(424) + .300_r8*rxt(129)*y(17)
         mat(122) = rxt(136)*y(5)
         mat(341) = mat(341) + .900_r8*rxt(143)*y(5)
         mat(380) = .060_r8*rxt(147)*y(1)
         mat(519) = mat(519) + rxt(148)*y(5) + rxt(149)*y(7) + rxt(152)*y(17) &
                      + rxt(153)*y(31)
         mat(535) = .060_r8*rxt(159)*y(1)
         mat(456) = .275_r8*rxt(161)*y(1)
         mat(500) = mat(500) + .470_r8*rxt(162)*y(5) + .470_r8*rxt(164)*y(7) &
                      + .730_r8*rxt(166)*y(17) + .470_r8*rxt(167)*y(31)
         mat(116) = .200_r8*rxt(168)*y(12)
         mat(550) = mat(550) + rxt(172)*y(17)
         mat(448) = rxt(134)*y(12)
         mat(483) = mat(483) + rxt(180)*y(5) + rxt(181)*y(7) + .800_r8*rxt(183)*y(17) &
                      + rxt(184)*y(31)
         mat(278) = rxt(199)*y(1)
         mat(439) = mat(439) + rxt(202)*y(5)
         mat(58) = .250_r8*rxt(187)*y(12)
         mat(238) = mat(238) + .900_r8*rxt(190)*y(5)
         mat(76) = .700_r8*rxt(189)*y(6)
         mat(231) = rxt(112)*y(12)
         mat(258) = .500_r8*rxt(141)*y(12)
         mat(326) = mat(326) + .794_r8*rxt(155)*y(5) + .794_r8*rxt(156)*y(7) &
                      + .794_r8*rxt(157)*y(13)
         mat(391) = rxt(178)*y(7) + rxt(177)*y(12)
         mat(106) = .500_r8*rxt(212)*y(12)
         mat(69) = .350_r8*rxt(89)*y(12)
         mat(158) = rxt(84)*y(12)
         mat(188) = mat(188) + rxt(87)*y(5)

         mat(63) = -(rxt(53)*y(12))
         mat(623) = -rxt(53)*y(14)

         mat(623) = mat(623) + 2.000_r8*rxt(56)*y(12)
         mat(560) = 2.000_r8*rxt(52)*y(13)

         mat(790) = -(rxt(74)*y(5) + (4._r8*rxt(75) + 4._r8*rxt(76)) * y(17) + rxt(77) &
                      *y(13) + rxt(98)*y(28) + rxt(106)*y(31) + rxt(124)*y(35) + rxt(129) &
                      *y(40) + rxt(152)*y(51) + rxt(166)*y(55) + rxt(172)*y(57) &
                      + rxt(183)*y(61))
         mat(731) = -rxt(74)*y(17)
         mat(608) = -rxt(77)*y(17)
         mat(356) = -rxt(98)*y(17)
         mat(812) = -rxt(106)*y(17)
         mat(367) = -rxt(124)*y(17)
         mat(427) = -rxt(129)*y(17)
         mat(523) = -rxt(152)*y(17)
         mat(503) = -rxt(166)*y(17)
         mat(554) = -rxt(172)*y(17)
         mat(486) = -rxt(183)*y(17)

         mat(761) = .310_r8*rxt(116)*y(33)
         mat(731) = mat(731) + rxt(103)*y(31)
         mat(687) = .700_r8*rxt(78)*y(18) + rxt(113)*y(25)
         mat(790) = mat(790) + .900_r8*rxt(106)*y(31)
         mat(149) = .700_r8*rxt(78)*y(12)
         mat(199) = rxt(113)*y(12)
         mat(812) = mat(812) + rxt(103)*y(5) + .900_r8*rxt(106)*y(17) &
                      + 4.000_r8*rxt(110)*y(31) + rxt(153)*y(51) + rxt(167)*y(55) &
                      + rxt(173)*y(57) + rxt(184)*y(61)
         mat(407) = .310_r8*rxt(116)*y(1)
         mat(523) = mat(523) + rxt(153)*y(31)
         mat(503) = mat(503) + rxt(167)*y(31)
         mat(554) = mat(554) + rxt(173)*y(31)
         mat(486) = mat(486) + rxt(184)*y(31)

         mat(145) = -(rxt(78)*y(12))
         mat(637) = -rxt(78)*y(18)

         mat(569) = rxt(77)*y(17)
         mat(766) = rxt(77)*y(13)

         mat(462) = -(rxt(79)*y(7) + rxt(80)*y(12) + rxt(85)*y(13))
         mat(853) = -rxt(79)*y(19)
         mat(676) = -rxt(80)*y(19)
         mat(597) = -rxt(85)*y(19)

         mat(750) = rxt(91)*y(22) + .540_r8*rxt(116)*y(33) + .600_r8*rxt(147)*y(50) &
                      + .800_r8*rxt(159)*y(53) + .700_r8*rxt(161)*y(54)
         mat(720) = rxt(74)*y(17) + rxt(118)*y(37) + rxt(127)*y(40) + .500_r8*rxt(136) &
                      *y(43) + .100_r8*rxt(143)*y(48) + .550_r8*rxt(148)*y(51) &
                      + .250_r8*rxt(162)*y(55) + rxt(169)*y(57) + .072_r8*rxt(155) &
                      *y(84)
         mat(853) = mat(853) + .600_r8*rxt(149)*y(51) + .250_r8*rxt(164)*y(55) &
                      + rxt(170)*y(57) + .072_r8*rxt(156)*y(84)
         mat(676) = mat(676) + .300_r8*rxt(78)*y(18) + rxt(83)*y(20) + .500_r8*rxt(90) &
                      *y(22) + .800_r8*rxt(111)*y(26) + .500_r8*rxt(107)*y(32) &
                      + rxt(108)*y(81) + .500_r8*rxt(141)*y(83)
         mat(597) = mat(597) + .008_r8*rxt(157)*y(84)
         mat(779) = rxt(74)*y(5) + (4.000_r8*rxt(75)+2.000_r8*rxt(76))*y(17) &
                      + .700_r8*rxt(98)*y(28) + rxt(106)*y(31) + rxt(124)*y(35) &
                      + .800_r8*rxt(129)*y(40) + 1.200_r8*rxt(152)*y(51) &
                      + .880_r8*rxt(166)*y(55) + 2.000_r8*rxt(172)*y(57) &
                      + .700_r8*rxt(183)*y(61)
         mat(146) = .300_r8*rxt(78)*y(12)
         mat(263) = rxt(83)*y(12)
         mat(153) = rxt(91)*y(1) + .500_r8*rxt(90)*y(12)
         mat(285) = .800_r8*rxt(111)*y(12)
         mat(352) = .700_r8*rxt(98)*y(17)
         mat(801) = rxt(106)*y(17) + .600_r8*rxt(153)*y(51) + .250_r8*rxt(167)*y(55) &
                      + rxt(173)*y(57)
         mat(201) = .500_r8*rxt(107)*y(12)
         mat(401) = .540_r8*rxt(116)*y(1)
         mat(363) = rxt(124)*y(17)
         mat(316) = rxt(118)*y(5)
         mat(422) = rxt(127)*y(5) + .800_r8*rxt(129)*y(17)
         mat(121) = .500_r8*rxt(136)*y(5)
         mat(339) = .100_r8*rxt(143)*y(5)
         mat(376) = .600_r8*rxt(147)*y(1)
         mat(512) = .550_r8*rxt(148)*y(5) + .600_r8*rxt(149)*y(7) + 1.200_r8*rxt(152) &
                      *y(17) + .600_r8*rxt(153)*y(31)
         mat(530) = .800_r8*rxt(159)*y(1)
         mat(452) = .700_r8*rxt(161)*y(1)
         mat(495) = .250_r8*rxt(162)*y(5) + .250_r8*rxt(164)*y(7) + .880_r8*rxt(166) &
                      *y(17) + .250_r8*rxt(167)*y(31)
         mat(547) = rxt(169)*y(5) + rxt(170)*y(7) + 2.000_r8*rxt(172)*y(17) + rxt(173) &
                      *y(31) + 4.000_r8*rxt(174)*y(57)
         mat(480) = .700_r8*rxt(183)*y(17)
         mat(213) = rxt(108)*y(12)
         mat(256) = .500_r8*rxt(141)*y(12)
         mat(324) = .072_r8*rxt(155)*y(5) + .072_r8*rxt(156)*y(7) + .008_r8*rxt(157) &
                      *y(13)

         mat(262) = -(rxt(83)*y(12))
         mat(657) = -rxt(83)*y(20)

         mat(770) = 2.000_r8*rxt(76)*y(17) + .300_r8*rxt(98)*y(28) + .500_r8*rxt(129) &
                      *y(40) + .250_r8*rxt(152)*y(51) + .250_r8*rxt(166)*y(55) &
                      + .300_r8*rxt(183)*y(61)
         mat(349) = .300_r8*rxt(98)*y(17)
         mat(419) = .500_r8*rxt(129)*y(17)
         mat(508) = .250_r8*rxt(152)*y(17)
         mat(491) = .250_r8*rxt(166)*y(17)
         mat(477) = .300_r8*rxt(183)*y(17)

         mat(109) = -(rxt(114)*y(12))
         mat(630) = -rxt(114)*y(21)

         mat(765) = .200_r8*rxt(98)*y(28)
         mat(347) = .200_r8*rxt(98)*y(17) + .800_r8*rxt(99)*y(28)

         mat(150) = -(rxt(90)*y(12) + rxt(91)*y(1))
         mat(638) = -rxt(90)*y(22)
         mat(736) = -rxt(91)*y(22)


         mat(695) = rxt(92)*y(24)
         mat(178) = rxt(92)*y(5)


      end subroutine nlnmat02

      subroutine nlnmat03( mat, y, rxt )

      use chem_mods, only : gas_pcnst, rxntot, nzcnt

      implicit none

!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      real(r8), intent(in) :: y(gas_pcnst)
      real(r8), intent(in) :: rxt(rxntot)
      real(r8), intent(inout) :: mat(nzcnt)


!----------------------------------------------
! ... local variables
!----------------------------------------------

!----------------------------------------------
! ... complete matrix entries implicit species
!----------------------------------------------


         mat(179) = -(rxt(92)*y(5))
         mat(700) = -rxt(92)*y(24)

         mat(644) = .750_r8*rxt(90)*y(22)
         mat(152) = .750_r8*rxt(90)*y(12)

         mat(197) = -(rxt(113)*y(12))
         mat(646) = -rxt(113)*y(25)

         mat(739) = .250_r8*rxt(116)*y(33) + .200_r8*rxt(147)*y(50)
         mat(574) = .250_r8*rxt(105)*y(31) + .250_r8*rxt(171)*y(57)
         mat(768) = .100_r8*rxt(106)*y(31)
         mat(795) = .250_r8*rxt(105)*y(13) + .100_r8*rxt(106)*y(17)
         mat(396) = .250_r8*rxt(116)*y(1)
         mat(370) = .200_r8*rxt(147)*y(1)
         mat(543) = .250_r8*rxt(171)*y(13)

         mat(284) = -(rxt(111)*y(12))
         mat(660) = -rxt(111)*y(26)

         mat(706) = .530_r8*rxt(162)*y(55) + .250_r8*rxt(180)*y(61)
         mat(844) = .530_r8*rxt(164)*y(55) + .250_r8*rxt(181)*y(61)
         mat(771) = .260_r8*rxt(166)*y(55) + .100_r8*rxt(183)*y(61)
         mat(798) = .530_r8*rxt(167)*y(55) + .250_r8*rxt(184)*y(61)
         mat(492) = .530_r8*rxt(162)*y(5) + .530_r8*rxt(164)*y(7) + .260_r8*rxt(166) &
                      *y(17) + .530_r8*rxt(167)*y(31)
         mat(478) = .250_r8*rxt(180)*y(5) + .250_r8*rxt(181)*y(7) + .100_r8*rxt(183) &
                      *y(17) + .250_r8*rxt(184)*y(31)

         mat(49) = -(rxt(95)*y(12))
         mat(619) = -rxt(95)*y(27)

         mat(350) = -(rxt(96)*y(5) + rxt(97)*y(13) + rxt(98)*y(17) + 4._r8*rxt(99) &
                      *y(28))
         mat(712) = -rxt(96)*y(28)
         mat(589) = -rxt(97)*y(28)
         mat(773) = -rxt(98)*y(28)

         mat(666) = rxt(95)*y(27) + .500_r8*rxt(100)*y(29)
         mat(50) = rxt(95)*y(12)
         mat(161) = .500_r8*rxt(100)*y(12)

         mat(160) = -(rxt(100)*y(12))
         mat(640) = -rxt(100)*y(29)

         mat(571) = rxt(97)*y(28)
         mat(348) = rxt(97)*y(13)

         mat(411) = -(rxt(101)*y(12) + rxt(102)*y(7))
         mat(671) = -rxt(101)*y(30)
         mat(849) = -rxt(102)*y(30)

         mat(746) = .500_r8*rxt(116)*y(33) + .040_r8*rxt(159)*y(53)
         mat(715) = rxt(96)*y(28) + .270_r8*rxt(122)*y(35) + rxt(118)*y(37) + rxt(136) &
                      *y(43) + .400_r8*rxt(143)*y(48) + rxt(138)*y(45)
         mat(671) = mat(671) + rxt(114)*y(21) + .500_r8*rxt(100)*y(29)
         mat(775) = .800_r8*rxt(98)*y(28)
         mat(110) = rxt(114)*y(12)
         mat(351) = rxt(96)*y(5) + .800_r8*rxt(98)*y(17) + 3.200_r8*rxt(99)*y(28)
         mat(162) = .500_r8*rxt(100)*y(12)
         mat(399) = .500_r8*rxt(116)*y(1)
         mat(361) = .270_r8*rxt(122)*y(5)
         mat(314) = rxt(118)*y(5)
         mat(120) = rxt(136)*y(5)
         mat(337) = .400_r8*rxt(143)*y(5)
         mat(301) = rxt(138)*y(5)
         mat(528) = .040_r8*rxt(159)*y(1)

         mat(813) = -(rxt(103)*y(5) + rxt(104)*y(6) + rxt(105)*y(13) + rxt(106)*y(17) &
                      + 4._r8*rxt(110)*y(31) + rxt(153)*y(51) + rxt(167)*y(55) + rxt(184) &
                      *y(61))
         mat(732) = -rxt(103)*y(31)
         mat(833) = -rxt(104)*y(31)
         mat(609) = -rxt(105)*y(31)
         mat(791) = -rxt(106)*y(31)
         mat(524) = -rxt(153)*y(31)
         mat(504) = -rxt(167)*y(31)
         mat(487) = -rxt(184)*y(31)

         mat(732) = mat(732) + rxt(127)*y(40) + rxt(138)*y(45) + .530_r8*rxt(162) &
                      *y(55) + rxt(169)*y(57)
         mat(865) = rxt(102)*y(30) + .530_r8*rxt(164)*y(55) + rxt(170)*y(57) &
                      + rxt(133)*y(60)
         mat(688) = rxt(101)*y(30) + .500_r8*rxt(107)*y(32) + rxt(132)*y(60)
         mat(791) = mat(791) + .300_r8*rxt(129)*y(40) + .260_r8*rxt(166)*y(55) &
                      + rxt(172)*y(57)
         mat(415) = rxt(102)*y(7) + rxt(101)*y(12)
         mat(813) = mat(813) + .530_r8*rxt(167)*y(55)
         mat(204) = .500_r8*rxt(107)*y(12)
         mat(428) = rxt(127)*y(5) + .300_r8*rxt(129)*y(17)
         mat(305) = rxt(138)*y(5)
         mat(504) = mat(504) + .530_r8*rxt(162)*y(5) + .530_r8*rxt(164)*y(7) &
                      + .260_r8*rxt(166)*y(17) + .530_r8*rxt(167)*y(31)
         mat(555) = rxt(169)*y(5) + rxt(170)*y(7) + rxt(172)*y(17) + 4.000_r8*rxt(174) &
                      *y(57)
         mat(472) = rxt(133)*y(7) + rxt(132)*y(12)

         mat(200) = -(rxt(107)*y(12))
         mat(647) = -rxt(107)*y(32)

         mat(575) = .750_r8*rxt(105)*y(31) + .750_r8*rxt(171)*y(57)
         mat(796) = .750_r8*rxt(105)*y(13)
         mat(544) = .750_r8*rxt(171)*y(13)

         mat(398) = -(rxt(115)*y(12) + rxt(116)*y(1) + rxt(117)*y(7))
         mat(670) = -rxt(115)*y(33)
         mat(745) = -rxt(116)*y(33)
         mat(848) = -rxt(117)*y(33)

         mat(745) = mat(745) + .070_r8*rxt(147)*y(50)
         mat(374) = .070_r8*rxt(147)*y(1)

         mat(46) = -(rxt(121)*y(12))
         mat(618) = -rxt(121)*y(34)

         mat(360) = -(rxt(122)*y(5) + rxt(123)*y(13) + rxt(124)*y(17))
         mat(713) = -rxt(122)*y(35)
         mat(590) = -rxt(123)*y(35)
         mat(774) = -rxt(124)*y(35)

         mat(667) = rxt(121)*y(34) + rxt(125)*y(36)
         mat(47) = rxt(121)*y(12)
         mat(142) = rxt(125)*y(12)

         mat(140) = -(rxt(125)*y(12))
         mat(636) = -rxt(125)*y(36)

         mat(568) = rxt(123)*y(35)
         mat(358) = rxt(123)*y(13)

         mat(313) = -(rxt(118)*y(5) + rxt(119)*y(13))
         mat(709) = -rxt(118)*y(37)
         mat(586) = -rxt(119)*y(37)

         mat(664) = rxt(115)*y(33) + .500_r8*rxt(120)*y(38)
         mat(397) = rxt(115)*y(12)
         mat(206) = .500_r8*rxt(120)*y(12)

         mat(205) = -(rxt(120)*y(12))
         mat(648) = -rxt(120)*y(38)

         mat(576) = rxt(119)*y(37)
         mat(312) = rxt(119)*y(13)

         mat(307) = -(rxt(126)*y(12))
         mat(663) = -rxt(126)*y(39)

         mat(708) = .820_r8*rxt(122)*y(35) + .500_r8*rxt(136)*y(43) + .250_r8*rxt(143) &
                      *y(48) + .100_r8*rxt(202)*y(64)
         mat(772) = .820_r8*rxt(124)*y(35)
         mat(359) = .820_r8*rxt(122)*y(5) + .820_r8*rxt(124)*y(17)
         mat(119) = .500_r8*rxt(136)*y(5)
         mat(334) = .250_r8*rxt(143)*y(5)
         mat(431) = .100_r8*rxt(202)*y(5)

         mat(420) = -(rxt(127)*y(5) + rxt(128)*y(13) + rxt(129)*y(17))
         mat(716) = -rxt(127)*y(40)
         mat(593) = -rxt(128)*y(40)
         mat(776) = -rxt(129)*y(40)

         mat(672) = rxt(126)*y(39) + rxt(130)*y(41)
         mat(308) = rxt(126)*y(12)
         mat(131) = rxt(130)*y(12)

         mat(130) = -(rxt(130)*y(12))
         mat(634) = -rxt(130)*y(41)

         mat(566) = rxt(128)*y(40)
         mat(418) = rxt(128)*y(13)

         mat(34) = -(rxt(135)*y(12))
         mat(614) = -rxt(135)*y(42)

         mat(118) = -(rxt(136)*y(5))
         mat(696) = -rxt(136)*y(43)

         mat(632) = rxt(135)*y(42)
         mat(35) = rxt(135)*y(12)

         mat(37) = -(rxt(142)*y(12))
         mat(615) = -rxt(142)*y(47)

         mat(335) = -(rxt(143)*y(5) + rxt(144)*y(13))
         mat(711) = -rxt(143)*y(48)
         mat(588) = -rxt(144)*y(48)

         mat(665) = rxt(142)*y(47) + rxt(145)*y(49)
         mat(38) = rxt(142)*y(12)
         mat(292) = rxt(145)*y(12)

         mat(289) = -(rxt(145)*y(12))
         mat(661) = -rxt(145)*y(49)

         mat(583) = rxt(144)*y(48)
         mat(332) = rxt(144)*y(13)

         mat(192) = -(rxt(137)*y(12))
         mat(645) = -rxt(137)*y(44)

         mat(702) = .750_r8*rxt(143)*y(48)
         mat(331) = .750_r8*rxt(143)*y(5)

         mat(300) = -(rxt(138)*y(5) + rxt(139)*y(13))
         mat(707) = -rxt(138)*y(45)
         mat(584) = -rxt(139)*y(45)

         mat(662) = rxt(137)*y(44) + rxt(140)*y(46)
         mat(193) = rxt(137)*y(12)
         mat(126) = rxt(140)*y(12)

         mat(125) = -(rxt(140)*y(12))
         mat(633) = -rxt(140)*y(46)

         mat(565) = rxt(139)*y(45)
         mat(299) = rxt(139)*y(13)

         mat(372) = -(rxt(146)*y(12) + rxt(147)*y(1) + rxt(154)*y(7))
         mat(668) = -rxt(146)*y(50)
         mat(743) = -rxt(147)*y(50)
         mat(846) = -rxt(154)*y(50)

         mat(516) = -(rxt(148)*y(5) + rxt(149)*y(7) + rxt(150)*y(13) + rxt(152)*y(17) &
                      + rxt(153)*y(31))
         mat(724) = -rxt(148)*y(51)
         mat(857) = -rxt(149)*y(51)
         mat(601) = -rxt(150)*y(51)
         mat(783) = -rxt(152)*y(51)
         mat(805) = -rxt(153)*y(51)

         mat(680) = rxt(146)*y(50) + .200_r8*rxt(151)*y(52)
         mat(377) = rxt(146)*y(12)
         mat(270) = .200_r8*rxt(151)*y(12)

         mat(266) = -(rxt(151)*y(12))
         mat(658) = -rxt(151)*y(52)

         mat(582) = rxt(150)*y(51)
         mat(509) = rxt(150)*y(13)

         mat(533) = -(rxt(158)*y(12) + rxt(159)*y(1))
         mat(681) = -rxt(158)*y(53)
         mat(755) = -rxt(159)*y(53)

         mat(755) = mat(755) + .200_r8*rxt(147)*y(50) + rxt(199)*y(63)
         mat(725) = .320_r8*rxt(148)*y(51) + rxt(202)*y(64) + .039_r8*rxt(155)*y(84)
         mat(858) = .350_r8*rxt(149)*y(51) + .039_r8*rxt(156)*y(84)
         mat(602) = .039_r8*rxt(157)*y(84)
         mat(784) = .260_r8*rxt(152)*y(51)
         mat(806) = .350_r8*rxt(153)*y(51)
         mat(378) = .200_r8*rxt(147)*y(1)
         mat(517) = .320_r8*rxt(148)*y(5) + .350_r8*rxt(149)*y(7) + .260_r8*rxt(152) &
                      *y(17) + .350_r8*rxt(153)*y(31)
         mat(277) = rxt(199)*y(1)
         mat(438) = rxt(202)*y(5)
         mat(325) = .039_r8*rxt(155)*y(5) + .039_r8*rxt(156)*y(7) + .039_r8*rxt(157) &
                      *y(13)


      end subroutine nlnmat03

      subroutine nlnmat04( mat, y, rxt )

      use chem_mods, only : gas_pcnst, rxntot, nzcnt

      implicit none

!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      real(r8), intent(in) :: y(gas_pcnst)
      real(r8), intent(in) :: rxt(rxntot)
      real(r8), intent(inout) :: mat(nzcnt)


!----------------------------------------------
! ... local variables
!----------------------------------------------

!----------------------------------------------
! ... complete matrix entries implicit species
!----------------------------------------------


         mat(451) = -(rxt(160)*y(12) + rxt(161)*y(1))
         mat(675) = -rxt(160)*y(54)
         mat(749) = -rxt(161)*y(54)

         mat(749) = mat(749) + .400_r8*rxt(147)*y(50) + rxt(199)*y(63)
         mat(719) = .230_r8*rxt(148)*y(51) + rxt(202)*y(64) + .167_r8*rxt(155)*y(84)
         mat(852) = .250_r8*rxt(149)*y(51) + .167_r8*rxt(156)*y(84)
         mat(596) = .167_r8*rxt(157)*y(84)
         mat(778) = .190_r8*rxt(152)*y(51)
         mat(800) = .250_r8*rxt(153)*y(51)
         mat(375) = .400_r8*rxt(147)*y(1)
         mat(511) = .230_r8*rxt(148)*y(5) + .250_r8*rxt(149)*y(7) + .190_r8*rxt(152) &
                      *y(17) + .250_r8*rxt(153)*y(31)
         mat(276) = rxt(199)*y(1)
         mat(435) = rxt(202)*y(5)
         mat(323) = .167_r8*rxt(155)*y(5) + .167_r8*rxt(156)*y(7) + .167_r8*rxt(157) &
                      *y(13)

         mat(498) = -((rxt(162) + rxt(163)) * y(5) + rxt(164)*y(7) + rxt(165)*y(13) &
                      + rxt(166)*y(17) + rxt(167)*y(31))
         mat(723) = -(rxt(162) + rxt(163)) * y(55)
         mat(856) = -rxt(164)*y(55)
         mat(600) = -rxt(165)*y(55)
         mat(782) = -rxt(166)*y(55)
         mat(804) = -rxt(167)*y(55)

         mat(679) = rxt(158)*y(53) + .500_r8*rxt(160)*y(54) + .200_r8*rxt(168)*y(56)
         mat(532) = rxt(158)*y(12)
         mat(454) = .500_r8*rxt(160)*y(12)
         mat(114) = .200_r8*rxt(168)*y(12)

         mat(113) = -(rxt(168)*y(12))
         mat(631) = -rxt(168)*y(56)

         mat(564) = rxt(165)*y(55)
         mat(490) = rxt(165)*y(13)

         mat(549) = -(rxt(169)*y(5) + rxt(170)*y(7) + rxt(171)*y(13) + rxt(172)*y(17) &
                      + rxt(173)*y(31) + 4._r8*rxt(174)*y(57) + rxt(175)*y(6))
         mat(726) = -rxt(169)*y(57)
         mat(859) = -rxt(170)*y(57)
         mat(603) = -rxt(171)*y(57)
         mat(785) = -rxt(172)*y(57)
         mat(807) = -rxt(173)*y(57)
         mat(827) = -rxt(175)*y(57)

         mat(756) = .200_r8*rxt(147)*y(50)
         mat(682) = .500_r8*rxt(160)*y(54) + .500_r8*rxt(168)*y(56)
         mat(379) = .200_r8*rxt(147)*y(1)
         mat(455) = .500_r8*rxt(160)*y(12)
         mat(115) = .500_r8*rxt(168)*y(12)

         mat(165) = -(rxt(179)*y(12))
         mat(641) = -rxt(179)*y(58)

         mat(698) = .370_r8*rxt(148)*y(51)
         mat(839) = .400_r8*rxt(149)*y(51) + rxt(178)*y(85)
         mat(641) = mat(641) + rxt(177)*y(85)
         mat(767) = .300_r8*rxt(152)*y(51)
         mat(794) = .400_r8*rxt(153)*y(51)
         mat(507) = .370_r8*rxt(148)*y(5) + .400_r8*rxt(149)*y(7) + .300_r8*rxt(152) &
                      *y(17) + .400_r8*rxt(153)*y(31)
         mat(387) = rxt(178)*y(7) + rxt(177)*y(12)

         mat(445) = -(rxt(134)*y(12))
         mat(674) = -rxt(134)*y(59)

         mat(718) = .220_r8*rxt(162)*y(55) + .250_r8*rxt(180)*y(61)
         mat(851) = .220_r8*rxt(164)*y(55) + .250_r8*rxt(181)*y(61)
         mat(674) = mat(674) + .500_r8*rxt(120)*y(38) + .500_r8*rxt(141)*y(83)
         mat(777) = .200_r8*rxt(129)*y(40) + .230_r8*rxt(166)*y(55) + .100_r8*rxt(183) &
                      *y(61)
         mat(799) = .220_r8*rxt(167)*y(55) + .250_r8*rxt(184)*y(61)
         mat(208) = .500_r8*rxt(120)*y(12)
         mat(421) = .200_r8*rxt(129)*y(17)
         mat(494) = .220_r8*rxt(162)*y(5) + .220_r8*rxt(164)*y(7) + .230_r8*rxt(166) &
                      *y(17) + .220_r8*rxt(167)*y(31)
         mat(479) = .250_r8*rxt(180)*y(5) + .250_r8*rxt(181)*y(7) + .100_r8*rxt(183) &
                      *y(17) + .250_r8*rxt(184)*y(31)
         mat(255) = .500_r8*rxt(141)*y(12)

         mat(469) = -(rxt(132)*y(12) + rxt(133)*y(7))
         mat(677) = -rxt(132)*y(60)
         mat(854) = -rxt(133)*y(60)

         mat(751) = .950_r8*rxt(159)*y(53) + .800_r8*rxt(161)*y(54)
         mat(721) = .250_r8*rxt(162)*y(55) + .250_r8*rxt(180)*y(61) + .450_r8*rxt(190) &
                      *y(68)
         mat(854) = mat(854) + .250_r8*rxt(164)*y(55) + .250_r8*rxt(181)*y(61)
         mat(677) = mat(677) + rxt(134)*y(59) + rxt(131)*y(82)
         mat(780) = .500_r8*rxt(129)*y(40) + .240_r8*rxt(166)*y(55) + .100_r8*rxt(183) &
                      *y(61)
         mat(802) = .250_r8*rxt(167)*y(55) + .250_r8*rxt(184)*y(61)
         mat(423) = .500_r8*rxt(129)*y(17)
         mat(531) = .950_r8*rxt(159)*y(1)
         mat(453) = .800_r8*rxt(161)*y(1)
         mat(496) = .250_r8*rxt(162)*y(5) + .250_r8*rxt(164)*y(7) + .240_r8*rxt(166) &
                      *y(17) + .250_r8*rxt(167)*y(31)
         mat(447) = rxt(134)*y(12)
         mat(481) = .250_r8*rxt(180)*y(5) + .250_r8*rxt(181)*y(7) + .100_r8*rxt(183) &
                      *y(17) + .250_r8*rxt(184)*y(31)
         mat(237) = .450_r8*rxt(190)*y(5)
         mat(175) = rxt(131)*y(12)

         mat(482) = -(rxt(180)*y(5) + rxt(181)*y(7) + rxt(182)*y(13) + rxt(183)*y(17) &
                      + rxt(184)*y(31))
         mat(722) = -rxt(180)*y(61)
         mat(855) = -rxt(181)*y(61)
         mat(599) = -rxt(182)*y(61)
         mat(781) = -rxt(183)*y(61)
         mat(803) = -rxt(184)*y(61)

         mat(678) = .800_r8*rxt(151)*y(52) + rxt(179)*y(58) + rxt(185)*y(62)
         mat(269) = .800_r8*rxt(151)*y(12)
         mat(166) = rxt(179)*y(12)
         mat(72) = rxt(185)*y(12)

         mat(71) = -((rxt(185) + rxt(186)) * y(12))
         mat(625) = -(rxt(185) + rxt(186)) * y(62)

         mat(561) = rxt(182)*y(61)
         mat(475) = rxt(182)*y(13)

         mat(274) = -(rxt(199)*y(1) + rxt(200)*y(12) + rxt(201)*y(7))
         mat(741) = -rxt(199)*y(63)
         mat(659) = -rxt(200)*y(63)
         mat(843) = -rxt(201)*y(63)

         mat(433) = -(rxt(202)*y(5) + rxt(203)*y(13))
         mat(717) = -rxt(202)*y(64)
         mat(594) = -rxt(203)*y(64)

         mat(850) = rxt(201)*y(63)
         mat(673) = rxt(200)*y(63) + rxt(204)*y(65)
         mat(275) = rxt(201)*y(7) + rxt(200)*y(12)
         mat(221) = rxt(204)*y(12)

         mat(219) = -(rxt(204)*y(12))
         mat(650) = -rxt(204)*y(65)

         mat(577) = rxt(203)*y(64)
         mat(430) = rxt(203)*y(13)

         mat(55) = -(rxt(187)*y(12))
         mat(621) = -rxt(187)*y(66)

         mat(60) = -(rxt(188)*y(12))
         mat(622) = -rxt(188)*y(67)

         mat(622) = mat(622) + .250_r8*rxt(187)*y(66)
         mat(56) = .250_r8*rxt(187)*y(12)

         mat(235) = -(rxt(190)*y(5) + rxt(191)*y(13))
         mat(704) = -rxt(190)*y(68)
         mat(579) = -rxt(191)*y(68)

         mat(653) = .700_r8*rxt(187)*y(66) + rxt(192)*y(69)
         mat(57) = .700_r8*rxt(187)*y(12)
         mat(170) = rxt(192)*y(12)

         mat(168) = -(rxt(192)*y(12))
         mat(642) = -rxt(192)*y(69)

         mat(572) = rxt(191)*y(68)
         mat(233) = rxt(191)*y(13)

         mat(74) = -(rxt(189)*y(6))
         mat(816) = -rxt(189)*y(78)

         mat(626) = rxt(188)*y(67)
         mat(61) = rxt(188)*y(12)


         mat(705) = .900_r8*rxt(190)*y(68)
         mat(821) = .700_r8*rxt(189)*y(78)
         mat(236) = .900_r8*rxt(190)*y(5)
         mat(75) = .700_r8*rxt(189)*y(6)

         mat(230) = -(rxt(112)*y(12))
         mat(652) = -rxt(112)*y(80)

         mat(703) = .250_r8*rxt(180)*y(61) + .450_r8*rxt(190)*y(68)
         mat(842) = .250_r8*rxt(181)*y(61)
         mat(652) = mat(652) + .200_r8*rxt(111)*y(26) + .650_r8*rxt(89)*y(118)
         mat(769) = .100_r8*rxt(183)*y(61)
         mat(283) = .200_r8*rxt(111)*y(12)
         mat(476) = .250_r8*rxt(180)*y(5) + .250_r8*rxt(181)*y(7) + .100_r8*rxt(183) &
                      *y(17)
         mat(234) = .450_r8*rxt(190)*y(5)
         mat(68) = .650_r8*rxt(89)*y(12)

         mat(40) = -(rxt(193)*y(12))
         mat(616) = -rxt(193)*y(70)

         mat(80) = -(rxt(194)*y(13) + rxt(195)*y(5))
         mat(562) = -rxt(194)*y(71)
         mat(693) = -rxt(195)*y(71)

         mat(627) = rxt(193)*y(70)
         mat(41) = rxt(193)*y(12)


         mat(691) = rxt(195)*y(71)
         mat(78) = rxt(195)*y(5)


         mat(558) = rxt(194)*y(71)
         mat(79) = rxt(194)*y(13)

         mat(43) = -(rxt(196)*y(12))
         mat(617) = -rxt(196)*y(74)

         mat(92) = -(rxt(197)*y(13) + rxt(198)*y(5))
         mat(563) = -rxt(197)*y(75)
         mat(694) = -rxt(198)*y(75)

         mat(628) = rxt(196)*y(74)
         mat(44) = rxt(196)*y(12)


         mat(692) = rxt(198)*y(75)
         mat(90) = rxt(198)*y(5)


         mat(559) = rxt(197)*y(75)
         mat(91) = rxt(197)*y(13)

         mat(212) = -(rxt(108)*y(12))
         mat(649) = -rxt(108)*y(81)

         mat(819) = rxt(104)*y(31)
         mat(797) = rxt(104)*y(6)

         mat(174) = -(rxt(131)*y(12))
         mat(643) = -rxt(131)*y(82)

         mat(699) = .100_r8*rxt(143)*y(48)
         mat(840) = rxt(117)*y(33)
         mat(395) = rxt(117)*y(7)
         mat(330) = .100_r8*rxt(143)*y(5)

         mat(254) = -(rxt(141)*y(12))
         mat(656) = -rxt(141)*y(83)

         mat(823) = rxt(175)*y(57)
         mat(545) = rxt(175)*y(6)

         mat(321) = -(rxt(155)*y(5) + rxt(156)*y(7) + rxt(157)*y(13))
         mat(710) = -rxt(155)*y(84)
         mat(845) = -rxt(156)*y(84)
         mat(587) = -rxt(157)*y(84)

         mat(845) = mat(845) + rxt(154)*y(50)
         mat(371) = rxt(154)*y(7)

         mat(388) = -(rxt(177)*y(12) + rxt(178)*y(7))
         mat(669) = -rxt(177)*y(85)
         mat(847) = -rxt(178)*y(85)

         mat(714) = .080_r8*rxt(148)*y(51) + .800_r8*rxt(163)*y(55) + .794_r8*rxt(155) &
                      *y(84)
         mat(847) = mat(847) + .794_r8*rxt(156)*y(84)
         mat(591) = .794_r8*rxt(157)*y(84)
         mat(510) = .080_r8*rxt(148)*y(5)
         mat(493) = .800_r8*rxt(163)*y(5)
         mat(322) = .794_r8*rxt(155)*y(5) + .794_r8*rxt(156)*y(7) + .794_r8*rxt(157) &
                      *y(13)


      end subroutine nlnmat04

      subroutine nlnmat05( mat, y, rxt )

      use chem_mods, only : gas_pcnst, rxntot, nzcnt

      implicit none

!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      real(r8), intent(in) :: y(gas_pcnst)
      real(r8), intent(in) :: rxt(rxntot)
      real(r8), intent(inout) :: mat(nzcnt)


!----------------------------------------------
! ... local variables
!----------------------------------------------

!----------------------------------------------
! ... complete matrix entries implicit species
!----------------------------------------------


         mat(53) = -(rxt(210)*y(12))
         mat(620) = -rxt(210)*y(100)

         mat(836) = rxt(213)*y(101)
         mat(620) = mat(620) + (rxt(211)+.500_r8*rxt(212))*y(101)
         mat(103) = rxt(213)*y(7) + (rxt(211)+.500_r8*rxt(212))*y(12)

         mat(104) = -((rxt(211) + rxt(212)) * y(12) + rxt(213)*y(7))
         mat(629) = -(rxt(211) + rxt(212)) * y(101)
         mat(838) = -rxt(213)*y(101)


         mat(612) = rxt(210)*y(100)
         mat(52) = rxt(210)*y(12)

         mat(32) = -(rxt(214)*y(12))
         mat(613) = -rxt(214)*y(103)
         mat(66) = -(rxt(89)*y(12))
         mat(624) = -rxt(89)*y(118)
         mat(157) = -(rxt(84)*y(12))
         mat(639) = -rxt(84)*y(119)
         mat(737) = .500_r8*rxt(91)*y(22)
         mat(697) = rxt(87)*y(120)
         mat(639) = mat(639) + .350_r8*rxt(89)*y(118)
         mat(570) = rxt(88)*y(120)
         mat(151) = .500_r8*rxt(91)*y(1)
         mat(67) = .350_r8*rxt(89)*y(12)
         mat(185) = rxt(87)*y(5) + rxt(88)*y(13)
         mat(186) = -(rxt(87)*y(5) + rxt(88)*y(13))
         mat(701) = -rxt(87)*y(120)
         mat(573) = -rxt(88)*y(120)
         mat(573) = mat(573) + rxt(85)*y(19)
         mat(460) = rxt(85)*y(13)
      end subroutine nlnmat05
      subroutine nlnmat_finit( mat, lmat, dti )
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      real(r8), intent(in) :: dti
      real(r8), intent(in) :: lmat(nzcnt)
      real(r8), intent(inout) :: mat(nzcnt)
!----------------------------------------------
! ... local variables
!----------------------------------------------
!----------------------------------------------
! ... complete matrix entries implicit species
!----------------------------------------------
         mat( 1) = lmat( 1)
         mat( 2) = lmat( 2)
         mat( 3) = lmat( 3)
         mat( 4) = lmat( 4)
         mat( 5) = lmat( 5)
         mat( 6) = lmat( 6)
         mat( 7) = lmat( 7)
         mat( 8) = lmat( 8)
         mat( 9) = lmat( 9)
         mat( 10) = lmat( 10)
         mat( 11) = lmat( 11)
         mat( 12) = lmat( 12)
         mat( 13) = lmat( 13)
         mat( 14) = lmat( 14)
         mat( 15) = lmat( 15)
         mat( 16) = lmat( 16)
         mat( 17) = lmat( 17)
         mat( 18) = lmat( 18)
         mat( 19) = lmat( 19)
         mat( 20) = lmat( 20)
         mat( 21) = lmat( 21)
         mat( 22) = lmat( 22)
         mat( 23) = lmat( 23)
         mat( 24) = lmat( 24)
         mat( 25) = lmat( 25)
         mat( 26) = lmat( 26)
         mat( 27) = lmat( 27)
         mat( 28) = lmat( 28)
         mat( 29) = lmat( 29)
         mat( 30) = lmat( 30)
         mat( 31) = lmat( 31)
         mat( 32) = mat( 32) + lmat( 32)
         mat( 34) = mat( 34) + lmat( 34)
         mat( 37) = mat( 37) + lmat( 37)
         mat( 40) = mat( 40) + lmat( 40)
         mat( 43) = mat( 43) + lmat( 43)
         mat( 46) = mat( 46) + lmat( 46)
         mat( 49) = mat( 49) + lmat( 49)
         mat( 53) = mat( 53) + lmat( 53)
         mat( 55) = mat( 55) + lmat( 55)
         mat( 60) = mat( 60) + lmat( 60)
         mat( 63) = mat( 63) + lmat( 63)
         mat( 65) = mat( 65) + lmat( 65)
         mat( 66) = mat( 66) + lmat( 66)
         mat( 71) = mat( 71) + lmat( 71)
         mat( 73) = mat( 73) + lmat( 73)
         mat( 74) = mat( 74) + lmat( 74)
         mat( 80) = mat( 80) + lmat( 80)
         mat( 83) = lmat( 83)
         mat( 84) = lmat( 84)
         mat( 85) = lmat( 85)
         mat( 86) = lmat( 86)
         mat( 87) = lmat( 87)
         mat( 88) = lmat( 88)
         mat( 89) = lmat( 89)
         mat( 92) = mat( 92) + lmat( 92)
         mat( 95) = lmat( 95)
         mat( 96) = lmat( 96)
         mat( 97) = lmat( 97)
         mat( 98) = lmat( 98)
         mat( 99) = lmat( 99)
         mat( 100) = lmat( 100)
         mat( 101) = lmat( 101)
         mat( 102) = lmat( 102)
         mat( 104) = mat( 104) + lmat( 104)
         mat( 109) = mat( 109) + lmat( 109)
         mat( 113) = mat( 113) + lmat( 113)
         mat( 118) = mat( 118) + lmat( 118)
         mat( 125) = mat( 125) + lmat( 125)
         mat( 127) = lmat( 127)
         mat( 128) = mat( 128) + lmat( 128)
         mat( 129) = lmat( 129)
         mat( 130) = mat( 130) + lmat( 130)
         mat( 132) = lmat( 132)
         mat( 133) = mat( 133) + lmat( 133)
         mat( 134) = lmat( 134)
         mat( 135) = mat( 135) + lmat( 135)
         mat( 136) = lmat( 136)
         mat( 137) = mat( 137) + lmat( 137)
         mat( 138) = mat( 138) + lmat( 138)
         mat( 139) = lmat( 139)
         mat( 140) = mat( 140) + lmat( 140)
         mat( 141) = lmat( 141)
         mat( 143) = lmat( 143)
         mat( 144) = mat( 144) + lmat( 144)
         mat( 145) = mat( 145) + lmat( 145)
         mat( 146) = mat( 146) + lmat( 146)
         mat( 147) = lmat( 147)
         mat( 148) = mat( 148) + lmat( 148)
         mat( 150) = mat( 150) + lmat( 150)
         mat( 157) = mat( 157) + lmat( 157)
         mat( 160) = mat( 160) + lmat( 160)
         mat( 162) = mat( 162) + lmat( 162)
         mat( 163) = lmat( 163)
         mat( 164) = mat( 164) + lmat( 164)
         mat( 165) = mat( 165) + lmat( 165)
         mat( 168) = mat( 168) + lmat( 168)
         mat( 169) = lmat( 169)
         mat( 171) = lmat( 171)
         mat( 172) = lmat( 172)
         mat( 173) = mat( 173) + lmat( 173)
         mat( 174) = mat( 174) + lmat( 174)
         mat( 179) = mat( 179) + lmat( 179)
         mat( 186) = mat( 186) + lmat( 186)
         mat( 187) = lmat( 187)
         mat( 188) = mat( 188) + lmat( 188)
         mat( 192) = mat( 192) + lmat( 192)
         mat( 194) = lmat( 194)
         mat( 196) = lmat( 196)
         mat( 197) = mat( 197) + lmat( 197)
         mat( 200) = mat( 200) + lmat( 200)
         mat( 202) = mat( 202) + lmat( 202)
         mat( 203) = lmat( 203)
         mat( 205) = mat( 205) + lmat( 205)
         mat( 207) = lmat( 207)
         mat( 209) = lmat( 209)
         mat( 210) = lmat( 210)
         mat( 211) = mat( 211) + lmat( 211)
         mat( 212) = mat( 212) + lmat( 212)
         mat( 215) = lmat( 215)
         mat( 216) = lmat( 216)
         mat( 217) = lmat( 217)
         mat( 218) = mat( 218) + lmat( 218)
         mat( 219) = mat( 219) + lmat( 219)
         mat( 220) = lmat( 220)
         mat( 222) = lmat( 222)
         mat( 223) = lmat( 223)
         mat( 224) = lmat( 224)
         mat( 225) = mat( 225) + lmat( 225)
         mat( 226) = mat( 226) + lmat( 226)
         mat( 227) = mat( 227) + lmat( 227)
         mat( 228) = lmat( 228)
         mat( 230) = mat( 230) + lmat( 230)
         mat( 231) = mat( 231) + lmat( 231)
         mat( 235) = mat( 235) + lmat( 235)
         mat( 242) = lmat( 242)
         mat( 243) = lmat( 243)
         mat( 244) = lmat( 244)
         mat( 245) = lmat( 245)
         mat( 247) = lmat( 247)
         mat( 248) = mat( 248) + lmat( 248)
         mat( 252) = mat( 252) + lmat( 252)
         mat( 254) = mat( 254) + lmat( 254)
         mat( 257) = lmat( 257)
         mat( 260) = lmat( 260)
         mat( 262) = mat( 262) + lmat( 262)
         mat( 266) = mat( 266) + lmat( 266)
         mat( 267) = lmat( 267)
         mat( 268) = lmat( 268)
         mat( 271) = lmat( 271)
         mat( 272) = lmat( 272)
         mat( 274) = mat( 274) + lmat( 274)
         mat( 284) = mat( 284) + lmat( 284)
         mat( 285) = mat( 285) + lmat( 285)
         mat( 286) = mat( 286) + lmat( 286)
         mat( 288) = lmat( 288)
         mat( 289) = mat( 289) + lmat( 289)
         mat( 291) = lmat( 291)
         mat( 294) = lmat( 294)
         mat( 295) = lmat( 295)
         mat( 296) = lmat( 296)
         mat( 297) = mat( 297) + lmat( 297)
         mat( 300) = mat( 300) + lmat( 300)
         mat( 307) = mat( 307) + lmat( 307)
         mat( 310) = lmat( 310)
         mat( 311) = lmat( 311)
         mat( 313) = mat( 313) + lmat( 313)
         mat( 321) = mat( 321) + lmat( 321)
         mat( 335) = mat( 335) + lmat( 335)
         mat( 350) = mat( 350) + lmat( 350)
         mat( 360) = mat( 360) + lmat( 360)
         mat( 372) = mat( 372) + lmat( 372)
         mat( 388) = mat( 388) + lmat( 388)
         mat( 389) = lmat( 389)
         mat( 391) = mat( 391) + lmat( 391)
         mat( 393) = mat( 393) + lmat( 393)
         mat( 398) = mat( 398) + lmat( 398)
         mat( 411) = mat( 411) + lmat( 411)
         mat( 412) = lmat( 412)
         mat( 414) = lmat( 414)
         mat( 420) = mat( 420) + lmat( 420)
         mat( 433) = mat( 433) + lmat( 433)
         mat( 445) = mat( 445) + lmat( 445)
         mat( 446) = lmat( 446)
         mat( 448) = mat( 448) + lmat( 448)
         mat( 450) = lmat( 450)
         mat( 451) = mat( 451) + lmat( 451)
         mat( 452) = mat( 452) + lmat( 452)
         mat( 455) = mat( 455) + lmat( 455)
         mat( 456) = mat( 456) + lmat( 456)
         mat( 457) = mat( 457) + lmat( 457)
         mat( 459) = lmat( 459)
         mat( 462) = mat( 462) + lmat( 462)
         mat( 463) = mat( 463) + lmat( 463)
         mat( 469) = mat( 469) + lmat( 469)
         mat( 470) = lmat( 470)
         mat( 472) = mat( 472) + lmat( 472)
         mat( 482) = mat( 482) + lmat( 482)
         mat( 498) = mat( 498) + lmat( 498)
         mat( 516) = mat( 516) + lmat( 516)
         mat( 527) = lmat( 527)
         mat( 533) = mat( 533) + lmat( 533)
         mat( 539) = lmat( 539)
         mat( 540) = lmat( 540)
         mat( 549) = mat( 549) + lmat( 549)
         mat( 560) = mat( 560) + lmat( 560)
         mat( 604) = mat( 604) + lmat( 604)
         mat( 683) = mat( 683) + lmat( 683)
         mat( 684) = mat( 684) + lmat( 684)
         mat( 687) = mat( 687) + lmat( 687)
         mat( 729) = mat( 729) + lmat( 729)
         mat( 735) = lmat( 735)
         mat( 740) = mat( 740) + lmat( 740)
         mat( 760) = mat( 760) + lmat( 760)
         mat( 790) = mat( 790) + lmat( 790)
         mat( 813) = mat( 813) + lmat( 813)
         mat( 820) = mat( 820) + lmat( 820)
         mat( 822) = mat( 822) + lmat( 822)
         mat( 829) = mat( 829) + lmat( 829)
         mat( 830) = mat( 830) + lmat( 830)
         mat( 834) = mat( 834) + lmat( 834)
         mat( 841) = mat( 841) + lmat( 841)
         mat( 862) = mat( 862) + lmat( 862)
         mat( 863) = lmat( 863)
         mat( 866) = mat( 866) + lmat( 866)
         mat( 867) = mat( 867) + lmat( 867)
         mat( 180) = 0._r8
         mat( 181) = 0._r8
         mat( 182) = 0._r8
         mat( 189) = 0._r8
         mat( 239) = 0._r8
         mat( 246) = 0._r8
         mat( 290) = 0._r8
         mat( 293) = 0._r8
         mat( 298) = 0._r8
         mat( 303) = 0._r8
         mat( 315) = 0._r8
         mat( 318) = 0._r8
         mat( 333) = 0._r8
         mat( 336) = 0._r8
         mat( 338) = 0._r8
         mat( 340) = 0._r8
         mat( 342) = 0._r8
         mat( 344) = 0._r8
         mat( 345) = 0._r8
         mat( 354) = 0._r8
         mat( 362) = 0._r8
         mat( 365) = 0._r8
         mat( 368) = 0._r8
         mat( 373) = 0._r8
         mat( 382) = 0._r8
         mat( 384) = 0._r8
         mat( 385) = 0._r8
         mat( 390) = 0._r8
         mat( 400) = 0._r8
         mat( 402) = 0._r8
         mat( 405) = 0._r8
         mat( 408) = 0._r8
         mat( 416) = 0._r8
         mat( 425) = 0._r8
         mat( 432) = 0._r8
         mat( 434) = 0._r8
         mat( 436) = 0._r8
         mat( 437) = 0._r8
         mat( 440) = 0._r8
         mat( 442) = 0._r8
         mat( 443) = 0._r8
         mat( 465) = 0._r8
         mat( 466) = 0._r8
         mat( 473) = 0._r8
         mat( 484) = 0._r8
         mat( 497) = 0._r8
         mat( 499) = 0._r8
         mat( 501) = 0._r8
         mat( 513) = 0._r8
         mat( 514) = 0._r8
         mat( 515) = 0._r8
         mat( 518) = 0._r8
         mat( 520) = 0._r8
         mat( 522) = 0._r8
         mat( 529) = 0._r8
         mat( 534) = 0._r8
         mat( 537) = 0._r8
         mat( 541) = 0._r8
         mat( 542) = 0._r8
         mat( 546) = 0._r8
         mat( 548) = 0._r8
         mat( 551) = 0._r8
         mat( 578) = 0._r8
         mat( 580) = 0._r8
         mat( 585) = 0._r8
         mat( 592) = 0._r8
         mat( 595) = 0._r8
         mat( 598) = 0._r8
         mat( 654) = 0._r8
         mat( 685) = 0._r8
         mat( 738) = 0._r8
         mat( 742) = 0._r8
         mat( 744) = 0._r8
         mat( 747) = 0._r8
         mat( 748) = 0._r8
         mat( 752) = 0._r8
         mat( 753) = 0._r8
         mat( 754) = 0._r8
         mat( 762) = 0._r8
         mat( 787) = 0._r8
         mat( 789) = 0._r8
         mat( 793) = 0._r8
         mat( 809) = 0._r8
         mat( 815) = 0._r8
         mat( 824) = 0._r8
         mat( 825) = 0._r8
         mat( 826) = 0._r8
         mat( 832) = 0._r8
         mat( 864) = 0._r8
         mat( 1) = mat( 1) - dti
         mat( 2) = mat( 2) - dti
         mat( 3) = mat( 3) - dti
         mat( 4) = mat( 4) - dti
         mat( 5) = mat( 5) - dti
         mat( 6) = mat( 6) - dti
         mat( 7) = mat( 7) - dti
         mat( 8) = mat( 8) - dti
         mat( 9) = mat( 9) - dti
         mat( 10) = mat( 10) - dti
         mat( 11) = mat( 11) - dti
         mat( 12) = mat( 12) - dti
         mat( 13) = mat( 13) - dti
         mat( 14) = mat( 14) - dti
         mat( 15) = mat( 15) - dti
         mat( 16) = mat( 16) - dti
         mat( 17) = mat( 17) - dti
         mat( 18) = mat( 18) - dti
         mat( 20) = mat( 20) - dti
         mat( 21) = mat( 21) - dti
         mat( 23) = mat( 23) - dti
         mat( 24) = mat( 24) - dti
         mat( 25) = mat( 25) - dti
         mat( 26) = mat( 26) - dti
         mat( 27) = mat( 27) - dti
         mat( 28) = mat( 28) - dti
         mat( 29) = mat( 29) - dti
         mat( 30) = mat( 30) - dti
         mat( 31) = mat( 31) - dti
         mat( 32) = mat( 32) - dti
         mat( 34) = mat( 34) - dti
         mat( 37) = mat( 37) - dti
         mat( 40) = mat( 40) - dti
         mat( 43) = mat( 43) - dti
         mat( 46) = mat( 46) - dti
         mat( 49) = mat( 49) - dti
         mat( 53) = mat( 53) - dti
         mat( 55) = mat( 55) - dti
         mat( 60) = mat( 60) - dti
         mat( 63) = mat( 63) - dti
         mat( 66) = mat( 66) - dti
         mat( 71) = mat( 71) - dti
         mat( 74) = mat( 74) - dti
         mat( 80) = mat( 80) - dti
         mat( 83) = mat( 83) - dti
         mat( 92) = mat( 92) - dti
         mat( 95) = mat( 95) - dti
         mat( 99) = mat( 99) - dti
         mat( 104) = mat( 104) - dti
         mat( 109) = mat( 109) - dti
         mat( 113) = mat( 113) - dti
         mat( 118) = mat( 118) - dti
         mat( 125) = mat( 125) - dti
         mat( 130) = mat( 130) - dti
         mat( 135) = mat( 135) - dti
         mat( 140) = mat( 140) - dti
         mat( 145) = mat( 145) - dti
         mat( 150) = mat( 150) - dti
         mat( 157) = mat( 157) - dti
         mat( 160) = mat( 160) - dti
         mat( 165) = mat( 165) - dti
         mat( 168) = mat( 168) - dti
         mat( 174) = mat( 174) - dti
         mat( 179) = mat( 179) - dti
         mat( 186) = mat( 186) - dti
         mat( 192) = mat( 192) - dti
         mat( 197) = mat( 197) - dti
         mat( 200) = mat( 200) - dti
         mat( 205) = mat( 205) - dti
         mat( 212) = mat( 212) - dti
         mat( 219) = mat( 219) - dti
         mat( 226) = mat( 226) - dti
         mat( 230) = mat( 230) - dti
         mat( 235) = mat( 235) - dti
         mat( 243) = mat( 243) - dti
         mat( 248) = mat( 248) - dti
         mat( 254) = mat( 254) - dti
         mat( 262) = mat( 262) - dti
         mat( 266) = mat( 266) - dti
         mat( 274) = mat( 274) - dti
         mat( 284) = mat( 284) - dti
         mat( 289) = mat( 289) - dti
         mat( 300) = mat( 300) - dti
         mat( 307) = mat( 307) - dti
         mat( 313) = mat( 313) - dti
         mat( 321) = mat( 321) - dti
         mat( 335) = mat( 335) - dti
         mat( 350) = mat( 350) - dti
         mat( 360) = mat( 360) - dti
         mat( 372) = mat( 372) - dti
         mat( 388) = mat( 388) - dti
         mat( 398) = mat( 398) - dti
         mat( 411) = mat( 411) - dti
         mat( 420) = mat( 420) - dti
         mat( 433) = mat( 433) - dti
         mat( 445) = mat( 445) - dti
         mat( 451) = mat( 451) - dti
         mat( 462) = mat( 462) - dti
         mat( 469) = mat( 469) - dti
         mat( 482) = mat( 482) - dti
         mat( 498) = mat( 498) - dti
         mat( 516) = mat( 516) - dti
         mat( 533) = mat( 533) - dti
         mat( 549) = mat( 549) - dti
         mat( 604) = mat( 604) - dti
         mat( 684) = mat( 684) - dti
         mat( 729) = mat( 729) - dti
         mat( 760) = mat( 760) - dti
         mat( 790) = mat( 790) - dti
         mat( 813) = mat( 813) - dti
         mat( 834) = mat( 834) - dti
         mat( 867) = mat( 867) - dti
      end subroutine nlnmat_finit
      subroutine nlnmat( mat, y, rxt, lmat, dti )
      use chem_mods, only : gas_pcnst, rxntot, nzcnt
      implicit none
!----------------------------------------------
! ... dummy arguments
!----------------------------------------------
      real(r8), intent(in) :: dti
      real(r8), intent(in) :: lmat(nzcnt)
      real(r8), intent(in) :: y(gas_pcnst)
      real(r8), intent(in) :: rxt(rxntot)
      real(r8), intent(inout) :: mat(nzcnt)
      call nlnmat01( mat, y, rxt )
      call nlnmat02( mat, y, rxt )
      call nlnmat03( mat, y, rxt )
      call nlnmat04( mat, y, rxt )
      call nlnmat05( mat, y, rxt )
      call nlnmat_finit( mat, lmat, dti )
      end subroutine nlnmat
      end module mo_nln_matrix
