
      module mo_sim_dat

      private
      public :: set_sim_dat

      contains

      subroutine set_sim_dat

      use chem_mods,   only : clscnt, cls_rxt_cnt, clsmap, permute, adv_mass, fix_mass, crb_mass
      use chem_mods,   only : diag_map
      use chem_mods,   only : phtcnt, rxt_tag_cnt, rxt_tag_lst, rxt_tag_map
      use chem_mods,   only : pht_alias_lst, pht_alias_mult
      use chem_mods,   only : extfrc_lst, inv_lst, slvd_lst
      use abortutils,  only : endrun
      use mo_tracname, only : solsym
      use chem_mods,   only : frc_from_dataset
      use shr_kind_mod,only : r8 => shr_kind_r8
      use cam_logfile, only : iulog

      implicit none

!--------------------------------------------------------------
!      ... local variables
!--------------------------------------------------------------
      integer :: ios

      clscnt(:) = (/     19,     0,     0,   132,     0 /)

      cls_rxt_cnt(:,1) = (/     49,    40,     0,    19 /)
      cls_rxt_cnt(:,4) = (/     15,   106,   209,   132 /)

      solsym(:151) = (/ 'O3              ','O               ','O1D             ','N2O             ','N               ', &
                        'NO              ','NO2             ','NO3             ','HNO3            ','HO2NO2          ', &
                        'N2O5            ','CH4             ','CH3O2           ','CH3OOH          ','CH3OH           ', &
                        'CH2O            ','CO              ','H2              ','H               ','OH              ', &
                        'HO2             ','H2O2            ','CLY             ','BRY             ','CL              ', &
                        'CL2             ','CLO             ','OCLO            ','CL2O2           ','HCL             ', &
                        'HOCL            ','CLONO2          ','BRCL            ','BR              ','BRO             ', &
                        'HBR             ','HOBR            ','BRONO2          ','CH3CL           ','CH3BR           ', &
                        'CFC11           ','CFC12           ','CFC113          ','HCFC22          ','CCL4            ', &
                        'CH3CCL3         ','CF3BR           ','CF2CLBR         ','C2H5OH          ','C2H4            ', &
                        'EO              ','EO2             ','CH3COOH         ','GLYALD          ','C2H6            ', &
                        'C2H5O2          ','C2H5OOH         ','CH3CHO          ','CH3CO3          ','CH3COOOH        ', &
                        'C3H6            ','C3H8            ','C3H7O2          ','C3H7OOH         ','PO2             ', &
                        'POOH            ','CH3COCH3        ','RO2             ','ROOH            ','BIGENE          ', &
                        'ENEO2           ','MEK             ','MEKO2           ','MEKOOH          ','BIGALK          ', &
                        'ALKO2           ','ALKOOH          ','ISOP            ','ISOPO2          ','ISOPOOH         ', &
                        'MVK             ','MACR            ','MACRO2          ','MACROOH         ','MCO3            ', &
                        'HYDRALD         ','HYAC            ','CH3COCHO        ','XO2             ','XOOH            ', &
                        'C10H16          ','TERPO2          ','TERPOOH         ','TOLUENE         ','CRESOL          ', &
                        'TOLO2           ','TOLOOH          ','XOH             ','BIGALD          ','GLYOXAL         ', &
                        'PAN             ','ONIT            ','MPAN            ','ISOPNO3         ','ONITR           ', &
                        'SOA             ','SO2             ','DMS             ','NH3             ','Rn              ', &
                        'Pb              ','CO2             ','HCN             ','CH3CN           ','C2H2            ', &
                        'HCOOH           ','HOCH2OO         ','H2SO4           ','SOAG            ','so4_a1          ', &
                        'nh4_a1          ','pom_a1          ','soa_a1          ','bc_a1           ','ncl_a1          ', &
                        'num_a1          ','so4_a2          ','nh4_a2          ','soa_a2          ','ncl_a2          ', &
                        'num_a2          ','pom_a3          ','bc_a3           ','num_a3          ','ncl_a4          ', &
                        'so4_a4          ','nh4_a4          ','num_a4          ','dst_a5          ','so4_a5          ', &
                        'nh4_a5          ','num_a5          ','ncl_a6          ','so4_a6          ','nh4_a6          ', &
                        'num_a6          ','dst_a7          ','so4_a7          ','nh4_a7          ','num_a7          ', &
                        'H2O             ' /)

      adv_mass(:151) = (/    47.998200_r8,    15.999400_r8,    15.999400_r8,    44.012880_r8,    14.006740_r8, &
                             30.006140_r8,    46.005540_r8,    62.004940_r8,    63.012340_r8,    79.011740_r8, &
                            108.010480_r8,    16.040600_r8,    47.032000_r8,    48.039400_r8,    32.040000_r8, &
                             30.025200_r8,    28.010400_r8,     2.014800_r8,     1.007400_r8,    17.006800_r8, &
                             33.006200_r8,    34.013600_r8,   100.916850_r8,    99.716850_r8,    35.452700_r8, &
                             70.905400_r8,    51.452100_r8,    67.451500_r8,   102.904200_r8,    36.460100_r8, &
                             52.459500_r8,    97.457640_r8,   115.356700_r8,    79.904000_r8,    95.903400_r8, &
                             80.911400_r8,    96.910800_r8,   141.908940_r8,    50.485900_r8,    94.937200_r8, &
                            137.367503_r8,   120.913206_r8,   187.375310_r8,    86.467906_r8,   153.821800_r8, &
                            133.402300_r8,   148.910210_r8,   165.364506_r8,    46.065800_r8,    28.051600_r8, &
                             61.057800_r8,    77.057200_r8,    60.050400_r8,    60.050400_r8,    30.066400_r8, &
                             61.057800_r8,    62.065200_r8,    44.051000_r8,    75.042400_r8,    76.049800_r8, &
                             42.077400_r8,    44.092200_r8,    75.083600_r8,    76.091000_r8,    91.083000_r8, &
                             92.090400_r8,    58.076800_r8,    89.068200_r8,    90.075600_r8,    56.103200_r8, &
                            105.108800_r8,    72.102600_r8,   103.094000_r8,   104.101400_r8,    72.143800_r8, &
                            103.135200_r8,   104.142600_r8,    68.114200_r8,   117.119800_r8,   118.127200_r8, &
                             70.087800_r8,    70.087800_r8,   119.093400_r8,   120.100800_r8,   101.079200_r8, &
                            100.113000_r8,    74.076200_r8,    72.061400_r8,   149.118600_r8,   150.126000_r8, &
                            136.228400_r8,   185.234000_r8,   186.241400_r8,    92.136200_r8,   108.135600_r8, &
                            173.140600_r8,   174.148000_r8,   190.147400_r8,    98.098200_r8,    58.035600_r8, &
                            121.047940_r8,   119.074340_r8,   147.084740_r8,   162.117940_r8,   147.125940_r8, &
                            144.132000_r8,    64.064800_r8,    62.132400_r8,    17.028940_r8,   222.000000_r8, &
                            207.200000_r8,    44.009800_r8,    27.025140_r8,    41.050940_r8,    26.036800_r8, &
                             46.024600_r8,    63.031400_r8,    98.078400_r8,    12.011000_r8,    96.063600_r8, &
                             18.036340_r8,    12.011000_r8,    12.011000_r8,    12.011000_r8,    58.442468_r8, &
                              1.007400_r8,    96.063600_r8,    18.036340_r8,    12.011000_r8,    58.442468_r8, &
                              1.007400_r8,    12.011000_r8,    12.011000_r8,     1.007400_r8,    58.442468_r8, &
                             96.063600_r8,    18.036340_r8,     1.007400_r8,   135.064039_r8,    96.063600_r8, &
                             18.036340_r8,     1.007400_r8,    58.442468_r8,    96.063600_r8,    18.036340_r8, &
                              1.007400_r8,   135.064039_r8,    96.063600_r8,    18.036340_r8,     1.007400_r8, &
                             18.014200_r8 /)

      crb_mass(:151) = (/     0.000000_r8,     0.000000_r8,     0.000000_r8,     0.000000_r8,     0.000000_r8, &
                              0.000000_r8,     0.000000_r8,     0.000000_r8,     0.000000_r8,     0.000000_r8, &
                              0.000000_r8,    12.011000_r8,    12.011000_r8,    12.011000_r8,    12.011000_r8, &
                             12.011000_r8,    12.011000_r8,     0.000000_r8,     0.000000_r8,     0.000000_r8, &
                              0.000000_r8,     0.000000_r8,    12.011000_r8,     0.000000_r8,     0.000000_r8, &
                              0.000000_r8,     0.000000_r8,     0.000000_r8,     0.000000_r8,     0.000000_r8, &
                              0.000000_r8,     0.000000_r8,     0.000000_r8,     0.000000_r8,     0.000000_r8, &
                              0.000000_r8,     0.000000_r8,     0.000000_r8,    12.011000_r8,    12.011000_r8, &
                             12.011000_r8,    12.011000_r8,    24.022000_r8,    12.011000_r8,    12.011000_r8, &
                             24.022000_r8,    12.011000_r8,    12.011000_r8,    24.022000_r8,    24.022000_r8, &
                             24.022000_r8,    24.022000_r8,    24.022000_r8,    24.022000_r8,    24.022000_r8, &
                             24.022000_r8,    24.022000_r8,    24.022000_r8,    24.022000_r8,    24.022000_r8, &
                             36.033000_r8,    36.033000_r8,    36.033000_r8,    36.033000_r8,    36.033000_r8, &
                             36.033000_r8,    36.033000_r8,    36.033000_r8,    36.033000_r8,    48.044000_r8, &
                             48.044000_r8,    48.044000_r8,    48.044000_r8,    48.044000_r8,    60.055000_r8, &
                             60.055000_r8,    60.055000_r8,    60.055000_r8,    60.055000_r8,    60.055000_r8, &
                             48.044000_r8,    48.044000_r8,    48.044000_r8,    48.044000_r8,    48.044000_r8, &
                             60.055000_r8,    36.033000_r8,    36.033000_r8,    60.055000_r8,    60.055000_r8, &
                            120.110000_r8,   120.110000_r8,   120.110000_r8,    84.077000_r8,    84.077000_r8, &
                             84.077000_r8,    84.077000_r8,    84.077000_r8,    60.055000_r8,    24.022000_r8, &
                             24.022000_r8,    36.033000_r8,    48.044000_r8,    60.055000_r8,    60.055000_r8, &
                            144.132000_r8,     0.000000_r8,    24.022000_r8,     0.000000_r8,     0.000000_r8, &
                              0.000000_r8,    12.011000_r8,    12.011000_r8,    24.022000_r8,    24.022000_r8, &
                             12.011000_r8,    12.011000_r8,     0.000000_r8,    12.011000_r8,     0.000000_r8, &
                              0.000000_r8,    12.011000_r8,    12.011000_r8,    12.011000_r8,     0.000000_r8, &
                              0.000000_r8,     0.000000_r8,     0.000000_r8,    12.011000_r8,     0.000000_r8, &
                              0.000000_r8,    12.011000_r8,    12.011000_r8,     0.000000_r8,     0.000000_r8, &
                              0.000000_r8,     0.000000_r8,     0.000000_r8,     0.000000_r8,     0.000000_r8, &
                              0.000000_r8,     0.000000_r8,     0.000000_r8,     0.000000_r8,     0.000000_r8, &
                              0.000000_r8,     0.000000_r8,     0.000000_r8,     0.000000_r8,     0.000000_r8, &
                              0.000000_r8 /)

      fix_mass(:  3) = (/ 0.00000000_r8, 28.0134800_r8, 31.9988000_r8 /)

      clsmap(: 19,1) = (/   12,   4,  17,  18,  39,  40,  41,  42,  43,  44, &
                            45,  46,  47,  48, 112,  23,  24, 110, 111 /)
      clsmap(:132,4) = (/    1,   2,   3,   5,   6,   7,  20,   8,   9,  10, &
                            11,  13,  14, 113, 114,  16,  19,  21,  22, 151, &
                            25,  26,  27,  28,  29,  30,  31,  32,  33,  34, &
                            35,  36,  37,  38,  15,  49,  50,  51,  52,  53, &
                            54,  55,  56,  57,  58,  59,  60,  61,  62,  63, &
                            64,  65,  66,  67,  68,  69,  70,  71,  75,  76, &
                            77,  72,  73,  74,  78,  79,  80,  81,  82,  83, &
                            84,  85,  86,  87,  88,  89,  90,  91,  92,  93, &
                            94,  95,  96,  97,  98,  99, 100, 101, 102, 103, &
                           104, 105, 107, 108, 109, 106, 115, 116, 117, 118, &
                           119, 120, 121, 122, 123, 124, 125, 126, 127, 128, &
                           129, 130, 131, 132, 133, 134, 135, 136, 137, 138, &
                           139, 140, 141, 142, 143, 144, 145, 146, 147, 148, &
                           149, 150 /)

      permute(:132,4) = (/  131, 130,  91,  49, 125, 126, 127, 121,  98,  67, &
                             55, 120,  68,  50,  38, 124, 102, 123,  87, 122, &
                            132,  47, 128,  46,  39, 114, 101, 104,  53, 111, &
                            129,  79,  96,  84,  80,  54,  61,  51,  70,  85, &
                             86,  40,  93,  60, 105, 118,  78, 103,  41,  99, &
                             69,  95,  83,  94, 106,  63,  35,  56,  36,  92, &
                             89,  71,  90,  57,  97, 117,  82, 115, 110, 116, &
                             58, 119,  62, 109, 112, 113,  59,  88, 108,  72, &
                             43,  44,  77,  64,  48,  75,  76,  73,  65,  81, &
                            107, 100,  42,  52,  37,   1,  45,  66,  74,   2, &
                              3,   4,   5,   6,   7,   8,   9,  10,  11,  12, &
                             13,  14,  15,  16,  17,  18,  19,  20,  21,  22, &
                             23,  24,  25,  26,  27,  28,  29,  30,  31,  32, &
                             33,  34 /)

      diag_map(:132) = (/    1,   2,   3,   4,   5,   6,   7,   8,   9,  10, &
                            11,  12,  13,  14,  15,  16,  17,  18,  19,  20, &
                            21,  22,  23,  24,  25,  26,  27,  28,  29,  30, &
                            31,  32,  33,  34,  35,  38,  41,  44,  47,  50, &
                            54,  59,  61,  66,  69,  74,  77,  79,  83,  87, &
                            91,  96, 101, 104, 108, 114, 121, 126, 131, 135, &
                           140, 147, 150, 156, 162, 166, 170, 176, 182, 189, &
                           195, 200, 207, 215, 222, 227, 233, 240, 246, 251, &
                           255, 263, 271, 279, 287, 292, 296, 303, 313, 324, &
                           332, 347, 361, 369, 376, 386, 395, 409, 416, 428, &
                           436, 443, 452, 468, 478, 488, 501, 515, 528, 534, &
                           545, 554, 567, 585, 601, 620, 640, 665, 682, 714, &
                           749, 763, 823, 842, 890, 922,1012,1033,1053,1076, &
                          1113,1133 /)

      extfrc_lst(: 11) = (/ 'NO              ','NO2             ','CO              ','SO2             ','so4_a1          ', &
                            'so4_a2          ','pom_a3          ','bc_a3           ','num_a1          ','num_a2          ', &
                            'num_a3          ' /)

      frc_from_dataset(: 11) = (/ .true., .true., .true., .true., .true., &
                                  .true., .true., .true., .true., .true., &
                                  .true. /)

      inv_lst(:  3) = (/ 'M               ', 'N2              ', 'O2              ' /)

      if( allocated( rxt_tag_lst ) ) then
         deallocate( rxt_tag_lst )
      end if
      allocate( rxt_tag_lst(rxt_tag_cnt),stat=ios )
      if( ios /= 0 ) then
         write(iulog,*) 'set_sim_dat: failed to allocate rxt_tag_lst; error = ',ios
         call endrun
      end if
      if( allocated( rxt_tag_map ) ) then
         deallocate( rxt_tag_map )
      end if
      allocate( rxt_tag_map(rxt_tag_cnt),stat=ios )
      if( ios /= 0 ) then
         write(iulog,*) 'set_sim_dat: failed to allocate rxt_tag_map; error = ',ios
         call endrun
      end if
      rxt_tag_lst(:rxt_tag_cnt) = (/ 'jo2_b           ', 'jo3_a           ', 'jo3_b           ', 'jn2o            ', &
                                     'jno             ', 'jno2            ', 'jn2o5_a         ', 'jn2o5_b         ', &
                                     'jhno3           ', 'jno3_a          ', 'jno3_b          ', 'jho2no2_a       ', &
                                     'jho2no2_b       ', 'jch3ooh         ', 'jch2o_a         ', 'jch2o_b         ', &
                                     'jch4_a          ', 'jch4_b          ', 'jch3cho         ', 'jpooh           ', &
                                     'jch3co3h        ', 'jpan            ', 'jmpan           ', 'jmacr_a         ', &
                                     'jmacr_b         ', 'jmvk            ', 'jc2h5ooh        ', 'jc3h7ooh        ', &
                                     'jrooh           ', 'jacet           ', 'jmgly           ', 'jxooh           ', &
                                     'jonitr          ', 'jisopooh        ', 'jhyac           ', 'jglyald         ', &
                                     'jmek            ', 'jbigald         ', 'jglyoxal        ', 'jalkooh         ', &
                                     'jmekooh         ', 'jtolooh         ', 'jterpooh        ', 'jh2o_a          ', &
                                     'jh2o_b          ', 'jh2o_c          ', 'jh2o2           ', 'jcl2            ', &
                                     'joclo           ', 'jcl2o2          ', 'jhocl           ', 'jhcl            ', &
                                     'jclono2_a       ', 'jclono2_b       ', 'jbrcl           ', 'jbro            ', &
                                     'jhobr           ', 'jbrono2_a       ', 'jbrono2_b       ', 'jch3cl          ', &
                                     'jccl4           ', 'jch3ccl3        ', 'jcfcl3          ', 'jcf2cl2         ', &
                                     'jcfc113         ', 'jhcfc22         ', 'jch3br          ', 'jcf3br          ', &
                                     'jcf2clbr        ', 'jco2            ', 'usr_O_O2        ', 'usr_O_O         ', &
                                     'o1d_n2          ', 'o1d_o2          ', 'ox_l1           ', 'ox_l2           ', &
                                     'ox_l3           ', 'usr_HO2_HO2     ', 'ox_p1           ', 'tag_NO2_NO3     ', &
                                     'usr_N2O5_M      ', 'tag_NO2_OH      ', 'usr_HNO3_OH     ', 'tag_NO2_HO2     ', &
                                     'usr_HO2NO2_M    ', 'ox_p2           ', 'usr_CO_OH_b     ', 'tag_C2H4_OH     ', &
                                     'ox_l6           ', 'ox_p5           ', 'ox_p4           ', 'tag_CH3CO3_NO2  ', &
                                     'ox_p16          ', 'usr_PAN_M       ', 'tag_C3H6_OH     ', 'ox_l4           ', &
                                     'ox_p9           ', 'ox_p3           ', 'usr_CH3COCH3_OH ', 'ox_p10          ', &
                                     'ox_p15          ', 'ox_l7           ', 'ox_p17          ', 'ox_l8           ', &
                                     'ox_p7           ', 'ox_p8           ', 'usr_MCO3_NO2    ', 'usr_MPAN_M      ', &
                                     'ox_l5           ', 'ox_p6           ', 'soa5            ', 'ox_p14          ', &
                                     'ox_p11          ', 'usr_XOOH_OH     ', 'soa4            ', 'ox_p12          ', &
                                     'soa2            ', 'soa1            ', 'soa3            ', 'ox_p13          ', &
                                     'usr_N2O5_aer    ', 'usr_NO3_aer     ', 'usr_NO2_aer     ', 'usr_SO2_OH      ', &
                                     'usr_DMS_OH      ', 'usr_HO2_aer     ', 'tag_CLO_CLO     ', 'usr_CL2O2_M     ', &
                                     'het1            ', 'het2            ', 'het3            ', 'het4            ', &
                                     'het5            ', 'het6            ', 'het7            ', 'het8            ', &
                                     'het9            ', 'het10           ', 'het11           ', 'het12           ', &
                                     'het13           ', 'het14           ', 'het15           ', 'het16           ', &
                                     'het17           ' /)
      rxt_tag_map(:rxt_tag_cnt) = (/    1,   2,   3,   4,   5,   6,   7,   8,   9,  10, &
                                       11,  12,  13,  14,  15,  16,  17,  18,  19,  20, &
                                       21,  22,  23,  24,  25,  26,  27,  28,  29,  30, &
                                       31,  32,  33,  34,  35,  36,  37,  38,  39,  40, &
                                       41,  42,  43,  44,  45,  46,  47,  48,  49,  50, &
                                       51,  52,  53,  54,  55,  56,  57,  58,  59,  60, &
                                       61,  62,  63,  64,  65,  66,  67,  68,  69,  70, &
                                       71,  73,  74,  75,  76,  90,  99, 100, 106, 111, &
                                      112, 113, 114, 119, 121, 123, 130, 142, 143, 145, &
                                      152, 153, 158, 164, 166, 167, 169, 174, 177, 178, &
                                      187, 189, 191, 195, 196, 203, 209, 210, 213, 215, &
                                      224, 228, 231, 237, 238, 239, 244, 245, 246, 247, &
                                      251, 252, 253, 254, 256, 259, 284, 285, 315, 316, &
                                      317, 318, 319, 320, 321, 322, 323, 324, 325, 326, &
                                      327, 328, 329, 330, 331 /)
      if( allocated( pht_alias_lst ) ) then
         deallocate( pht_alias_lst )
      end if
      allocate( pht_alias_lst(phtcnt,2),stat=ios )
      if( ios /= 0 ) then
         write(iulog,*) 'set_sim_dat: failed to allocate pht_alias_lst; error = ',ios
         call endrun
      end if
      if( allocated( pht_alias_mult ) ) then
         deallocate( pht_alias_mult )
      end if
      allocate( pht_alias_mult(phtcnt,2),stat=ios )
      if( ios /= 0 ) then
         write(iulog,*) 'set_sim_dat: failed to allocate pht_alias_mult; error = ',ios
         call endrun
      end if
      pht_alias_lst(:,1) = (/ 'userdefined     ', '                ', '                ', '                ', &
                              'userdefined     ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ' /)
      pht_alias_lst(:,2) = (/ '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', 'jch3ooh         ', &
                              'jh2o2           ', '                ', 'jpan            ', '                ', &
                              '                ', '                ', 'jch3ooh         ', 'jch3ooh         ', &
                              'jch3ooh         ', '                ', '                ', 'jch3ooh         ', &
                              'jch3cho         ', 'jch3ooh         ', '                ', '                ', &
                              'jacet           ', 'jno2            ', 'jmgly           ', 'jch3ooh         ', &
                              'jch3ooh         ', 'jch3ooh         ', 'jch3ooh         ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ', '                ', '                ', &
                              '                ', '                ' /)
      pht_alias_mult(:,1) = (/ 1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8 /)
      pht_alias_mult(:,2) = (/ 1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          .28_r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, .2_r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8, &
                          1._r8, 1._r8, 1._r8, 1._r8, 1._r8 /)

      end subroutine set_sim_dat

      end module mo_sim_dat
