<?xml version="1.0" encoding="UTF-8"?>
<!-- edited with XMLSPY v5 rel. 3 U (http://www.xmlspy.com) by Son H. Kim (JGCRI) -->
<!--XML file generated by XMLSPY v5 rel. 3 U (http://www.xmlspy.com)-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
	<xsl:template match="/">
		<scenario>
			<!--xsl:attribute name="xmlns:xsi"><xsl:value-of select="@xmlns:xsi"/></xsl:attribute-->
			<!--xsl:attribute name="xmlns:noNamespaceSchemaLocation">
				<xsl:value-of select="@xmlns:noNamespaceSchemaLocation"/></xsl:attribute-->
			<xsl:attribute name="name"><xsl:value-of select="scenario/@name"/></xsl:attribute>
			<xsl:attribute name="date"><xsl:value-of select="scenario/@date"/></xsl:attribute>
			<summary>"SRES B2 Scenario is used for this Reference Scenario"</summary>
			<modeltime>
				<startyear><xsl:value-of select="scenario/modeltime/startyear"/></startyear>
				<interyear1><xsl:value-of select="scenario/modeltime/interyear1"/></interyear1>
				<interyear2><xsl:value-of select="scenario/modeltime/interyear2"/></interyear2>
				<endyear><xsl:value-of select="scenario/modeltime/endyear"/></endyear>
				<timestep1>	<xsl:value-of select="scenario/modeltime/timestep1"/>	</timestep1>
				<timestep2>	<xsl:value-of select="scenario/modeltime/timestep2"/>	</timestep2>
				<timestep3>	<xsl:value-of select="scenario/modeltime/timestep3"/>	</timestep3>
				<popbegin>	<xsl:value-of select="scenario/modeltime/popbegin"/>	</popbegin>
				<dataend> <xsl:value-of select="scenario/modeltime/dataend"/> </dataend>
				<datatimestep>	<xsl:value-of select="scenario/modeltime/datatimestep"/></datatimestep>
			</modeltime>
			<world>
				<xsl:for-each select="scenario/world/region">
					<region> <xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
						<e_GNP_elas><xsl:value-of select="e_GNP_elas"/></e_GNP_elas>
						<demographics>
							<xsl:for-each select="demographics/population">
							<population>
								<xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
								<xsl:value-of select="."/>
							</population>
							</xsl:for-each>
							<xsl:for-each select="demographics/laborproductivity">
							<laborproductivity>
								<xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
								<xsl:value-of select="."/>
							</laborproductivity>
							</xsl:for-each>
							<xsl:for-each select="demographics/laborforce">
							<laborforce>
								<xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
								<xsl:value-of select="."/>
							</laborforce>
							</xsl:for-each>
						</demographics>
						<xsl:for-each select="resource">
						<resource> <xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
							<market> <xsl:value-of select="market"/>	</market>
							<xsl:for-each select="price">
							<price> <xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
								<xsl:value-of select="."/>
							</price>
							</xsl:for-each>
							<xsl:for-each select="subresource">
							<subresource><xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
									<xsl:for-each select="grade">
									<grade>
										<xsl:for-each select="period">
										<period>
											<name>	<xsl:value-of select="name"/></name>
											<year><xsl:value-of select="year"/></year>
											<available><xsl:value-of select="available"/></available>
											<extractioncost><xsl:value-of select="extractioncost"/></extractioncost>
											<environmentalcost><xsl:value-of select="environmentalcost"/></environmentalcost>
											<severencetax><xsl:value-of select="severencetax"/></severencetax>
											<techchange><xsl:value-of select="techchange"/></techchange>
										</period>
										</xsl:for-each>
									</grade>
									</xsl:for-each>
								<xsl:for-each select="annualprod">
									<annualprod> <xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
									<xsl:value-of select="."/></annualprod>
								</xsl:for-each>
								<xsl:for-each select="min_annualprod">
									<min_annualprod> <xsl:value-of select="."/></min_annualprod>
								</xsl:for-each>
							</subresource>
							</xsl:for-each>
						</resource>
						</xsl:for-each>
						<xsl:for-each select="supplysector">
						<supplysector><xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
								<market><xsl:value-of select="market"/></market>
								<xsl:for-each select="price">
								<price> <xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
									<xsl:value-of select="."/>
								</price>
								</xsl:for-each>
								<xsl:for-each select="output">
								<output> <xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
									<xsl:value-of select="."/>
								</output>
								</xsl:for-each>
								<xsl:for-each select="subsector">
									<subsector>
										<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
										<xsl:for-each select="capacitylimit">
										<capacitylimit> <xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
											<xsl:value-of select="."/>
										</capacitylimit>
										</xsl:for-each>
										<xsl:for-each select="sharewt">
										<sharewt> <xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
											<xsl:value-of select="."/>
										</sharewt>
										</xsl:for-each>
										<xsl:for-each select="logitexp">
										<logitexp> <xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
											<xsl:value-of select="."/>
										</logitexp>
										</xsl:for-each>
										<xsl:for-each select="technology">
											<technology>
												<xsl:for-each select="period">
													<period>
														<name><xsl:value-of select="name"/></name>
														<year><xsl:value-of select="year"/></year>
														<fueltype><xsl:value-of select="fueltype"/></fueltype>
														<sharewt><xsl:value-of select="sharewt"/></sharewt>															<fuelname><xsl:value-of select="fuelname"/></fuelname>
														<efficiency><xsl:value-of select="efficiency"/></efficiency>
														<nonenergycost><xsl:value-of select="nonenergycost"/></nonenergycost>
														<tax><xsl:value-of select="tax"/></tax>
														<logitexp><xsl:value-of select="logitexp"/></logitexp>
														<techchange><xsl:value-of select="techchange"/></techchange>
														<resource><xsl:value-of select="resource"/></resource>
														<A><xsl:value-of select="A"/></A>
														<B><xsl:value-of select="B"/></B>
														<xsl:for-each select="GHG">
															<GHG><xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
																<unit><xsl:value-of select="unit"/></unit>
																<emisscoef><xsl:value-of select="emisscoef"/></emisscoef>
																<removefrac><xsl:value-of select="removefrac"/></removefrac>
																<GWP><xsl:value-of select="GWP"/></GWP>
															</GHG>
														</xsl:for-each>
													</period>
												</xsl:for-each>
											</technology>
										</xsl:for-each>
									</subsector>
								</xsl:for-each>
						</supplysector>
						</xsl:for-each>
						<xsl:for-each select="demandsector">
						<demandsector><xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
								<xsl:attribute name="perCapitaBased"><xsl:value-of select="@perCapitaBased"/></xsl:attribute>
								<market><xsl:value-of select="market"/></market>
								<xsl:for-each select="price">
								<price> <xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
									<xsl:value-of select="."/>
								</price>
								</xsl:for-each>
								<xsl:for-each select="output">
								<output> <xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
									<xsl:value-of select="."/>
								</output>
								</xsl:for-each>
								<xsl:for-each select="serviceoutput">
								<serviceoutput><xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
									<xsl:value-of select="."/>
								</serviceoutput>
								</xsl:for-each>
								<xsl:for-each select="energyconsumption">
								<energyconsumption><xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
									<xsl:value-of select="."/>
								</energyconsumption>
								</xsl:for-each>
								<xsl:for-each select="incomeelasticity">
								<incomeelasticity><xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
									<xsl:value-of select="."/>
								</incomeelasticity>
								</xsl:for-each>
								<xsl:for-each select="subsector">
									<subsector>
										<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
										<xsl:for-each select="capacitylimit">
										<capacitylimit> <xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
											<xsl:value-of select="."/>
										</capacitylimit>
										</xsl:for-each>
										<xsl:for-each select="sharewt">
										<sharewt> <xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
											<xsl:value-of select="."/>
										</sharewt>
										</xsl:for-each>
										<xsl:for-each select="logitexp">
										<logitexp> <xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
											<xsl:value-of select="."/>
										</logitexp>
										</xsl:for-each>
										<xsl:for-each select="technology">
											<technology>
												<xsl:for-each select="period">
													<period>
														<name><xsl:value-of select="name"/></name>
														<year><xsl:value-of select="year"/></year>
														<fueltype><xsl:value-of select="fueltype"/></fueltype>
														<sharewt><xsl:value-of select="sharewt"/></sharewt>																<fuelname><xsl:value-of select="fuelname"/></fuelname>
														<efficiency><xsl:value-of select="efficiency"/></efficiency>
														<nonenergycost><xsl:value-of select="nonenergycost"/></nonenergycost>
														<tax><xsl:value-of select="tax"/></tax>
														<logitexp><xsl:value-of select="logitexp"/></logitexp>
														<techchange><xsl:value-of select="techchange"/></techchange>
														<resource><xsl:value-of select="resource"/></resource>
														<A><xsl:value-of select="A"/></A>
														<B><xsl:value-of select="B"/></B>
														<xsl:for-each select="GHG">
															<GHG><xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
																<unit><xsl:value-of select="unit"/></unit>
																<emisscoef><xsl:value-of select="emisscoef"/></emisscoef>
																<removefrac><xsl:value-of select="removefrac"/></removefrac>
																<GWP><xsl:value-of select="GWP"/></GWP>
															</GHG>
														</xsl:for-each>
													</period>
												</xsl:for-each>
											</technology>
										</xsl:for-each>
									</subsector>
								</xsl:for-each>
							</demandsector>
						</xsl:for-each>
						<xsl:for-each select="ghgmarket">
							<ghgmarket><xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
								<market><xsl:value-of select="market"/></market>
								<note><xsl:value-of select="note"/></note>
								<xsl:for-each select="period">
									<period><xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
										<constraint><xsl:value-of select="."/></constraint>
									</period>
								</xsl:for-each>
							</ghgmarket>
						</xsl:for-each>
						<xsl:for-each select="economicdata">
						<economicdata>
							<xsl:for-each select="GNP">
							<GNP><xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
								<xsl:value-of select="."/>
							</GNP>
							</xsl:for-each>
							<xsl:for-each select="incomeelasticity">
							<incomeelasticity><xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
								<xsl:value-of select="."/>
							</incomeelasticity>
							</xsl:for-each>
						</economicdata>
						</xsl:for-each>
						<xsl:for-each select="taxes">
						<taxes>
							<xsl:for-each select="carbontax">
							<carbontax><xsl:attribute name="year"><xsl:value-of select="@year"/></xsl:attribute>
								<xsl:value-of select="."/>
							</carbontax>
							</xsl:for-each>
						</taxes>
						</xsl:for-each>
					</region>
				</xsl:for-each>
			</world>
		</scenario>
	</xsl:template>
</xsl:stylesheet>
